function [alpha,stat] = alpha_marg_norm_rnd(C_0,C_1,n,r,Omega,beta,cu_symmetric)

b_c = inverse(beta'*C_1*beta);
mean_vec = vec(C_0*beta*b_c);
%
cov_mat = kron(b_c,Omega);
[std_mat,stat] = chol(cov_mat);
if stat>0;
   alpha = [];
   return;
end;
if cu_symmetric==1;
   std_mat = symm(cov_mat);
end;

alpha_vec = mean_vec+(std_mat'*randn(n*r,1));
alpha = vecinv(alpha_vec,n);

%
% end of alpha_marg_norm_rnd.m
%
