function [A,Sigma_A,C,dC_theta,Sigma_B_adj] = amat_sr_vlaar(B,Sigma_B,Psi,alpha,beta,epsilon,Z1,Z2,p,d,ind,Sigma_pi)

%
% for use only with the vlaar routine, when there are no long run restrictions
%

r = size(alpha,2);
n = size(epsilon,1);

if (r==0)&(p==1);
   C = eye(n);
   A = B;
   Sigma_A = Sigma_B;
   dC_theta = [];
else;
   if r<n;
      [C,Sigma_C,dC_theta,Sigma_theta] = cmat(Psi,alpha,beta,epsilon,Z1,Z2,p,d,ind,Sigma_pi);
   elseif r==n;
      [C,Sigma_C,dC_theta,Sigma_theta] = cmat_stat(Psi,alpha,beta,epsilon,Z1,Z2,p,d,ind,Sigma_pi);
   end;
   %
   A = C*B;
   b_i = kron(B',eye(n));
   i_c = kron(eye(n),C);
   Sigma_A = (b_i*Sigma_C*b_i')+(i_c*Sigma_B*i_c');
end;

Sigma_B_adj = Sigma_B;

%
% end of amat_sr_vlaar.m
%
