function beta = beta_margin_rank_rnd(C_0,C_1,alpha,S,K_mat,c_mat,c_mat_orth,df_psi,draw)

[n r] = size(alpha);

Pi_hat = C_0*inverse(C_1);
alpha_S = alpha'*inverse(S)*alpha;
beta_hat = K_mat*Pi_hat'*inverse(S)*alpha*inverse(alpha_S);
beta_hat_1 = beta_hat(1:r,:);
beta_hat_2 = beta_hat(r+1:n,:);
G_mat = (K_mat*inverse(C_1)*K_mat')+(K_mat*Pi_hat'*inverse(S)*Pi_hat*K_mat')-(beta_hat*alpha_S*beta_hat');
G_1 = G_mat(1:r,1:r);
G_2 = G_mat(1:r,r+1:n);
G_3 = G_mat(r+1:n,r+1:n);
dev_mat = eye(r)-beta_hat_1;
Psi_hat = beta_hat_2+(G_2'*inverse(G_1)*dev_mat);
P_beta = inverse((G_3-(G_2'*inverse(G_1)*G_2)));
Q_beta = (dev_mat'*inverse(G_1)*dev_mat)+inverse(alpha_S);
Psi = matrix_t_rnd(Psi_hat,P_beta,Q_beta,df_psi,draw);
beta = c_mat+(c_mat_orth*Psi);

%
% end of beta_margin_rank_rnd.m
%
