function outstring = betastr(A,tol,s);

if nargin<2;
   tol = '%12.4f';
end;

%
% A is kxl numeric matrix
% s is integer
%

[k l] = size(A);

if (nargin==1)|(nargin==2);
   prependstr = '   ';
   appendstr = ' ';
elseif nargin==3;
   prependstr = '';
   if isnumeric(s)==1;
      s = round(s);
      if s>=2;
         i = 1;
         while i<=s;
            prependstr = [prependstr ' '];
            i = i+1;
         end;
         appendstr = '';
         i = 1;
         while i<=s-2;
            appendstr = [appendstr ' '];
            i = i+1;
         end;
      else;
         return;
      end;
   else;
      return;
   end;
else;
   return;
end;

xappendstr = ' ';
for i=1:l;
   prependstr = strvcat(prependstr,[num2str(i) ':' appendstr]);
   xappendstr = strvcat(xappendstr,' ');
end;

% outstring = strvcat(' ',[prependstr num2str([(1:k);A']) xappendstr],' ');
outstring = strvcat(' ',[prependstr num2str([(1:k);A'],tol) xappendstr],' ');

%
% end of betastr.m
%