function checkobj_fcn

h = get(0,'CurrentFigure');

if isempty(get(h,'CurrentObject'))==1;
   return;
end;

toolbar = get(h,'UserData');
myaxes = get(toolbar.print,'UserData');
this_colorbar = findobj(gcf,'Type','axes','Tag','colorbar')';
if isempty(this_colorbar)==0;
   if strcmp(get(this_colorbar,'Visible'),'on')==1;
      kids = sort(get(this_colorbar,'Children')');
      myaxes = [myaxes this_colorbar kids];
   end;
end;

action = '';
for i=1:size(myaxes,2);
   if get(h,'CurrentObject')==myaxes(1,i);
      action = 'moveaxis';
      break;
   end;
end;

if strcmp(action,'moveaxis')==1;
   moveaxis_fcn;
end;

%
% end of checkobj_fcn.m
%
