function fitted_terms(Z_0,Z_1,Z_2,mytheta,mybeta,p,d,origname,freq,samplebeg,sampleend,outputdir)

%
% read var.ini
%

external = 0;
graphicsfmt = 'eps';
aiviewer = '';
epsviewer = '';
bitmapviewer = '';
colors = 0;
landscape = 0;
paperposmode = 'manual';
papertype = 'usletter';
xgrid = 0;
box = 0;
ygrid = 0;
paperunits = 'inches';
if strcmp(computer,'PCWIN')==1;
   axes_fontname = 'Arial';
   axes_fontsize = 7;
   title_fontname = 'Arial';
   title_fontsize = 8;
   label_fontname = 'Arial';
   label_fontsize = 7;
elseif strcmp(computer,'MAC2')==1;
   axes_fontname = 'Helvetica';
   axes_fontsize = 7;
   title_fontname = 'Helvetica';
   title_fontsize = 8;
   label_fontname = 'Helvetica';
   label_fontsize = 7;
else;
   axes_fontname = 'Helvetica';
   axes_fontsize = 7;
   title_fontname = 'Helvetica';
   title_fontsize = 8;
   label_fontname = 'Helvetica';
   label_fontsize = 7;
end;
axes_fontweight = 'normal';
axes_fontangle = 'normal';
axes_fontunits = 'points';
axes_color = [0 0 0];
title_fontweight = 'normal';
title_fontangle = 'normal';
title_fontunits = 'points';
title_color = [0 0 0];
label_fontweight = 'normal';
label_fontangle = 'normal';
label_fontunits = 'points';
label_color = [0 0 0];
invert_hardcopy = 1;
center_value = 6;
fill_value = 6;
fid = fopen('var.ini','rt');
if fid>-1;
   fclose(fid);
   inifile = readtext('var.ini');
   external = inifile{8};
   external = strrep(external,'external apps = ','');
   external = mystr2num(external);
   graphicsfmt = inifile{9};
   graphicsfmt = strrep(graphicsfmt,'graphics format = ','');
   aiviewer = inifile{10};
   aiviewer = strrep(aiviewer,'ai-viewer = ','');
   epsviewer = inifile{11};
   epsviewer = strrep(epsviewer,'eps-viewer = ','');
   bitmapviewer = inifile{12};
   bitmapviewer = strrep(bitmapviewer,'bitmap-viewer = ','');
   colors = inifile{15};
   colors = strrep(colors,'color graphs = ','');
   colors = mystr2num(colors);
   landscape = inifile{16};
   landscape = strrep(landscape,'landscape = ','');
   landscape = mystr2num(landscape);
   paperposmode = inifile{17};
   paperposmode = strrep(paperposmode,'paper position mode = ','');
   papertype = inifile{18};
   papertype = strrep(papertype,'paper type = ','');
   xgrid = inifile{20};
   xgrid = strrep(xgrid,'x-grid lines = ','');
   xgrid = mystr2num(xgrid);
   box = inifile{21};
   box = strrep(box,'box graphs = ','');
   box = mystr2num(box);
   ygrid = inifile{34};
   ygrid = strrep(ygrid,'y-grid lines = ','');
   ygrid = mystr2num(ygrid);
   paperunits = inifile{61};
   paperunits = strrep(paperunits,'paperunits = ','');
   axes_fontname = inifile{71};
   axes_fontname = strrep(axes_fontname,'axes font name = ','');
   axes_fontsize = inifile{72};
   axes_fontsize = strrep(axes_fontsize,'axes font size = ','');
   axes_fontsize = mystr2num(axes_fontsize);
   axes_fontweight = inifile{73};
   axes_fontweight = strrep(axes_fontweight,'axes font weight = ','');
   axes_fontangle = inifile{74};
   axes_fontangle = strrep(axes_fontangle,'axes font angle = ','');
   axes_fontunits = inifile{75};
   axes_fontunits = strrep(axes_fontunits,'axes font units = ','');
   axes_color = inifile{76};
   axes_color = strrep(axes_color,'axes color = ','');
   axes_color = mystr2num(axes_color);
   title_fontname = inifile{77};
   title_fontname = strrep(title_fontname,'title font name = ','');
   title_fontsize = inifile{78};
   title_fontsize = strrep(title_fontsize,'title font size = ','');
   title_fontsize = mystr2num(title_fontsize);
   title_fontweight = inifile{79};
   title_fontweight = strrep(title_fontweight,'title font weight = ','');
   title_fontangle = inifile{80};
   title_fontangle = strrep(title_fontangle,'title font angle = ','');
   title_fontunits = inifile{81};
   title_fontunits = strrep(title_fontunits,'title font units = ','');
   title_color = inifile{82};
   title_color = strrep(title_color,'title color = ','');
   title_color = mystr2num(title_color);
   label_fontname = inifile{83};
   label_fontname = strrep(label_fontname,'label font name = ','');
   label_fontsize = inifile{84};
   label_fontsize = strrep(label_fontsize,'label font size = ','');
   label_fontsize = mystr2num(label_fontsize);
   label_fontweight = inifile{85};
   label_fontweight = strrep(label_fontweight,'label font weight = ','');
   label_fontangle = inifile{86};
   label_fontangle = strrep(label_fontangle,'label font angle = ','');
   label_fontunits = inifile{87};
   label_fontunits = strrep(label_fontunits,'label font units = ','');
   label_color = inifile{88};
   label_color = strrep(label_color,'label color = ','');
   label_color = mystr2num(label_color);
   invert_hardcopy = inifile{94};
   invert_hardcopy = strrep(invert_hardcopy,'color printing = ','');
   invert_hardcopy = mystr2num(invert_hardcopy);
   center_value = inifile{95};
   center_value = strrep(center_value,'centering = ','');
   center_value = mystr2num(center_value);
   fill_value = inifile{96};
   fill_value = strrep(fill_value,'filling = ','');
   fill_value = mystr2num(fill_value);
end;
graphviewer = '';
if isnumeric(external)==0;
   external = 0;
end;
if external==1;
   if strcmp(graphicsfmt,'eps')==1;
      fid = fopen(epsviewer,'rb');
      if fid>-1;
         fclose(fid);
         graphviewer = epsviewer;
      else;
         external = 0;
      end;
   elseif strcmp(graphicsfmt,'ai')==1;
      fid = fopen(aiviewer,'rb');
      if fid>-1;
         fclose(fid);
         graphviewer = aiviewer;
      else;
         external = 0;
      end;
   else;
      if strcmp(graphicsfmt,'fig')==0;
         fid = fopen(bitmapviewer,'rb');
         if fid>-1;
            fclose(fid);
            graphviewer = bitmapviewer;
         else;
            external = 0;
         end;
      end;
   end;
end;

if colors==1;
   colorstr = 'b';
   colorstr2 = 'r';
   typestr = '-';
else;
   colorstr = 'k';
   colorstr2 = [0.5 0.5 0.5];
   typestr = '--';
end;
if landscape==1;
   orientstr = 'landscape';
else;
   orientstr = 'portrait';
end;
if invert_hardcopy==1;
   inv_hardcopy = 'on';
else;
   inv_hardcopy = 'off';
end;
%
% setting up the actual sample period
%
if strcmp(freq,'q')==1;
   nsamplebeg = samplebeg-(1/8);
   nsampleend = sampleend-(1/8);
   add = 1/4;
elseif strcmp(freq,'m')==1;
   nsamplebeg = samplebeg-(1/24);
   nsampleend = sampleend-(1/24);
   add = 1/12;
else;
   nsamplebeg = samplebeg;
   nsampleend = sampleend;
   add = 1;
end;
dataindex = nsamplebeg;
lastentry = dataindex;
j = 2;
while lastentry<=nsampleend;
   lastentry = dataindex(j-1,1)+add;
   if lastentry<=nsampleend;
      dataindex = [dataindex;lastentry];
      j = j+1;
   else;
      break;
   end;
end;
checkyear = floor(nsamplebeg);
checkperiod = nsamplebeg-checkyear;
beginyear = num2str(checkyear);
if strcmp(freq,'q')==1;
   checkperiod = 4*(checkperiod+(1/8));
   beginperiod = num2str(round(checkperiod));
elseif strcmp(freq,'m')==1;
   checkperiod = 12*(checkperiod+(1/24));
   beginperiod = num2str(round(checkperiod));
end;

%
% preliminaries
%

namevector = vecstr(origname);

[n T] = size(Z_0);
if isempty(mybeta)==0;
   r = size(mybeta,2);
else;
   r = 0;
end;
if d>0;
   Z_2_deter = Z_2(1:d,:);
   Z_0_corr = Z_0-((Z_0*Z_2_deter'/(Z_2_deter*Z_2_deter'))*Z_2_deter);
else;
   Z_2_deter = [];
   Z_0_corr = Z_0;
end;

if p>1;
   Gamma_endo = mytheta(:,d+1:n*(p-1)+d);
   Z_2_endo = Z_2(d+1:n*(p-1)+d,:);
else;
   Gamma_endo = [];
   Z_2_endo = [];
end;
n2 = size(mytheta,2);
myalpha = mytheta(:,n2-r+1:n2);

diff_vars = [];
if p>1;
   for j=1:n;
      for i=1:n;
         diff_varsi = 0;
         for k=1:p-1;
            i1 = i+(k-1)*n;
            diff_varsi = diff_varsi+(Gamma_endo(j,i1)*Z_2_endo(i1,:));
         end;
         diff_vars = [diff_vars;diff_varsi];
      end;
   end;
end;

if d>0;
   diff_vars = diff_vars-((diff_vars*Z_2_deter'/(Z_2_deter*Z_2_deter'))*Z_2_deter);
end;

if r>0;
   coint_rel = mybeta'*Z_1;
   coint_vars = [];
   for j=1:n;
      for i=1:r;
         coint_vars = [coint_vars;myalpha(j,i)*coint_rel(i,:)];
      end;
   end;
   if d>0;
      coint_vars = coint_vars-((coint_vars*Z_2_deter'/(Z_2_deter*Z_2_deter'))*Z_2_deter);
   end;
end;

%
% setting up the graphs
%

num_cols = floor(sqrt(n));
num_rows = ceil(n/num_cols);
if num_cols*num_rows<n;
   num_rows = num_rows+1;
end;
realscrsz = get(0,'ScreenSize');
%width = min(num_cols*350,realscrsz(3));
%height = min(num_rows*0.7*350,realscrsz(4));
%width = min(num_rows*350,realscrsz(3));
width = min(num_cols*500,realscrsz(3));
height = min((realscrsz(4)/realscrsz(3))*(width-100),realscrsz(4));

%
% first difference terms
%

thispos = [(realscrsz(3)-width)/2-22 (realscrsz(4)-height)/2+22];
for j=1:n;
   if p>1;
      diff_series = diff_vars(1+((j-1)*n):j*n,:);
      endo_series = Z_0_corr(j,:);
      %
      % fixing the position
      %
      thispos = [thispos(1,1)+22 thispos(1,2)-22];
      if thispos(1,1)>(realscrsz(3)-width);
         thispos = [0 realscrsz(4)-height];
      end;
      if thispos(1,2)>(realscrsz(4)-height);
         thispos = [0 realscrsz(4)-height];
      elseif thispos(1,2)<32;
         thispos = [0 realscrsz(4)-height];
      end;
      myplot = figure('Position',[thispos width height], ...
         'Color',get(0,'defaultuicontrolbackgroundcolor'), ...
         'NumberTitle','off', ...
         'Visible','off', ...
         'PaperUnits',paperunits, ...
         'PaperOrientation',orientstr, ...
         'PaperPositionMode',paperposmode, ...
         'PaperType',papertype, ...
         'InvertHardcopy',inv_hardcopy, ...
         'Name',[strtrim(namevector(j,:)) ' and fitted lagged first difference terms']);
      %
      % obey centering and filling defaults
      %
      center_fill_figure(myplot,fill_value,center_value);
      %
      %
      % Setting up the sub plots
      %
      axeshandles = [];
      for i=1:n;
         subplot(num_rows,num_cols,i);
         plot(dataindex,endo_series','-','LineWidth',1,'Color',colorstr);
         hold('on');
         plot(dataindex,diff_series(i,:)',typestr,'LineWidth',1,'Color',colorstr2);
         hold('on');
         plot(dataindex,zeros(T,1),'-','LineWidth',1,'Color','k');
         if xgrid==1;
            set(gca,'XGrid','on');
         end;
         if ygrid==1;
            set(gca,'YGrid','on');
         end;
         if box==1;
            set(gca,'Box','on');
         else;
            set(gca,'Box','off');
         end;
         set(gca,'XLim',[dataindex(1,1) dataindex(size(dataindex,1),1)]);
         set(gca,'FontSize',axes_fontsize);
         set(gca,'FontName',axes_fontname);
         set(gca,'FontWeight',axes_fontweight);
         set(gca,'FontAngle',axes_fontangle);
         set(gca,'FontUnits',axes_fontunits);
         set(gca,'XColor',axes_color);
         set(gca,'YColor',axes_color);
         set(get(gca,'XLabel'),'FontName',label_fontname);
         set(get(gca,'XLabel'),'FontSize',label_fontsize);
         set(get(gca,'XLabel'),'FontWeight',label_fontweight);
         set(get(gca,'XLabel'),'FontAngle',label_fontangle);
         set(get(gca,'XLabel'),'FontUnits',label_fontunits);
         set(get(gca,'XLabel'),'Color',label_color);
         set(get(gca,'YLabel'),'FontName',label_fontname);
         set(get(gca,'YLabel'),'FontSize',label_fontsize);
         set(get(gca,'YLabel'),'FontWeight',label_fontweight);
         set(get(gca,'YLabel'),'FontAngle',label_fontangle);
         set(get(gca,'YLabel'),'FontUnits',label_fontunits);
         set(get(gca,'YLabel'),'Color',label_color);
         thish = title(['\Delta' strtrim(namevector(j,:)) ' and fitted terms for lagged \Delta' strtrim(namevector(i,:))]);
         set(thish,'FontSize',title_fontsize);
         set(thish,'FontName',title_fontname);
         set(thish,'FontWeight',title_fontweight);
         set(thish,'FontAngle',title_fontangle);
         set(thish,'FontUnits',title_fontunits);
         set(thish,'Color',title_color);
         myleg = legend_fcn(['\Delta ' strtrim(namevector(j,:))],['Lagged \Delta' strtrim(namevector(i,:))],2);
         text_h = findobj(myleg,'Type','text');
         for i0=1:size(text_h,1);
            set(text_h(i0,1),'FontName',axes_fontname);
            set(text_h(i0,1),'FontSize',axes_fontsize);
            set(text_h(i0,1),'FontWeight',axes_fontweight);
            set(text_h(i0,1),'FontAngle',axes_fontangle);
            set(text_h(i0,1),'FontUnits',axes_fontunits);
            set(text_h(i0,1),'Color',axes_color);
         end;
         set(gca,'UserData',myleg);
         axeshandles = [axeshandles gca];
         hold('off');
      end;
      toolbar_fcn(axeshandles);
      %
      % take care of automatically saving the graphs
      %
      if external==0;
         set(myplot,'Visible','on');
         drawnow;
         drawnow;
      else;
         useres = '';
         file1 = [outputdir 'diff-' strtrim(namevector(j,:)) '-lagged-diffs-fitted-terms.' graphicsfmt];
         if (colors==1)&strcmp(graphicsfmt,'eps')==1;
            mstat = saveas_fcn(myplot,file1,'epsc');
            delete(myplot);
         else;
            if strcmp(graphicsfmt,'bmp')==1;
               set(myplot,'Visible','on');
            end;
            mstat = saveas_fcn(myplot,file1);
            if strcmp(graphicsfmt,'bmp')==1;
               set(myplot,'Visible','off');
            end;
            delete(myplot);
         end;
         if strcmp(graphicsfmt,'fig')==0;
            if mstat==0;
               if strcmp(computer,'PCWIN')==1;
                  program1 = [graphviewer ' ' file1 ' &'];
                  program1 = fixcmd(program1);
                  dos(program1);
               else;
                  if isunix==1;
                     program1 = [graphviewer ' ' file1];
                     unix(program1);
                  end;
               end;
            end;
         else;
            if mstat==0;
               openfig_fcn(file1);
               set(get(0,'CurrentFigure'),'Visible','on');
            else;
               text = strvcat(' ','MatLab''s figure format is not supported in stand-alone mode.');
               about(text,'information','Bad format...');
            end;
         end;
      end;
   end;
end;

if r>0;
   n_cols = floor(sqrt(r));
   n_rows = ceil(r/n_cols);
   if n_cols*n_rows<r;
      n_rows = n_rows+1;
   end;
   %c_width = min(n_rows*350,realscrsz(3));
   c_width = min(n_cols*500,realscrsz(3));
   %c_height = min(n_rows*0.7*350,realscrsz(4));
   c_height = min((realscrsz(4)/realscrsz(3))*(c_width-100),realscrsz(4));

   %
   % cointegration relations
   %

   last_pos = get(gcf,'Position');
   thispos = last_pos(1:2)+[0 height-c_height];

   for j=1:n;
      coint_series = coint_vars(1+((j-1)*r):j*r,:);
      endo_series = Z_0_corr(j,:);
      thispos = [thispos(1,1)+22 thispos(1,2)-22];
      if thispos(1,1)>(realscrsz(3)-c_width);
         thispos = [0 realscrsz(4)-c_height];
      end;
      if thispos(1,2)>(realscrsz(4)-c_height);
         thispos = [0 realscrsz(4)-c_height];
      elseif thispos(1,2)<32;
         thispos = [0 realscrsz(4)-c_height];
      end;
      myplot = figure('Position',[thispos c_width c_height], ...
         'Color',get(0,'defaultuicontrolbackgroundcolor'), ...
         'NumberTitle','off', ...
         'Visible','off', ...
         'PaperUnits',paperunits, ...
         'PaperOrientation',orientstr, ...
         'PaperPositionMode',paperposmode, ...
         'PaperType',papertype, ...
         'InvertHardcopy',inv_hardcopy, ...
         'Name',[strtrim(namevector(j,:)) ' and fitted lagged cointegration relations']);
      %
      % obey centering and filling defaults
      %
      center_fill_figure(myplot,fill_value,center_value);
      %
      %
      % Setting up the sub plots
      %
      axeshandles = [];
      for i=1:r;
         subplot(n_rows,n_cols,i);
         plot(dataindex,endo_series','-','LineWidth',1,'Color',colorstr);
         hold('on');
         plot(dataindex,coint_series(i,:)',typestr,'LineWidth',1,'Color',colorstr2);
         hold('on');
         plot(dataindex,zeros(T,1),'-','LineWidth',1,'Color','k');
         if xgrid==1;
            set(gca,'XGrid','on');
         end;
         if ygrid==1;
            set(gca,'YGrid','on');
         end;
         if box==1;
            set(gca,'Box','on');
         else;
            set(gca,'Box','off');
         end;
         set(gca,'XLim',[dataindex(1,1) dataindex(size(dataindex,1),1)]);
         set(gca,'FontSize',axes_fontsize);
         set(gca,'FontName',axes_fontname);
         set(gca,'FontWeight',axes_fontweight);
         set(gca,'FontAngle',axes_fontangle);
         set(gca,'FontUnits',axes_fontunits);
         set(gca,'XColor',axes_color);
         set(gca,'YColor',axes_color);
         set(get(gca,'XLabel'),'FontName',label_fontname);
         set(get(gca,'XLabel'),'FontSize',label_fontsize);
         set(get(gca,'XLabel'),'FontWeight',label_fontweight);
         set(get(gca,'XLabel'),'FontAngle',label_fontangle);
         set(get(gca,'XLabel'),'FontUnits',label_fontunits);
         set(get(gca,'XLabel'),'Color',label_color);
         set(get(gca,'YLabel'),'FontName',label_fontname);
         set(get(gca,'YLabel'),'FontSize',label_fontsize);
         set(get(gca,'YLabel'),'FontWeight',label_fontweight);
         set(get(gca,'YLabel'),'FontAngle',label_fontangle);
         set(get(gca,'YLabel'),'FontUnits',label_fontunits);
         set(get(gca,'YLabel'),'Color',label_color);
         thish = title(['\Delta' strtrim(namevector(j,:)) ' and fitted terms for cointegration relation ' num2str(i)]);
         set(thish,'FontSize',title_fontsize);
         set(thish,'FontName',title_fontname);
         set(thish,'FontWeight',title_fontweight);
         set(thish,'FontAngle',title_fontangle);
         set(thish,'FontUnits',title_fontunits);
         set(thish,'Color',title_color);
         myleg = legend_fcn(['\Delta ' strtrim(namevector(j,:))],['Coint. rel. no. ' num2str(i)],2);
         text_h = findobj(myleg,'Type','text');
         for i0=1:size(text_h,1);
            set(text_h(i0,1),'FontName',axes_fontname);
            set(text_h(i0,1),'FontSize',axes_fontsize);
            set(text_h(i0,1),'FontWeight',axes_fontweight);
            set(text_h(i0,1),'FontAngle',axes_fontangle);
            set(text_h(i0,1),'FontUnits',axes_fontunits);
            set(text_h(i0,1),'Color',axes_color);
         end;
         set(gca,'UserData',myleg);
         axeshandles = [axeshandles gca];
         hold('off');
      end;
      toolbar_fcn(axeshandles);
      %
      % take care of automatically saving the graphs
      %
      if external==0;
         set(myplot,'Visible','on');
         drawnow;
         drawnow;
      else;
         useres = '';
         file1 = [outputdir 'diff-' strtrim(namevector(j,:)) '-coint-relations-fitted-terms.' graphicsfmt];
         if (colors==1)&strcmp(graphicsfmt,'eps')==1;
            mstat = saveas_fcn(myplot,file1,'epsc');
            delete(myplot);
         else;
            if strcmp(graphicsfmt,'bmp')==1;
               set(myplot,'Visible','on');
            end;
            mstat = saveas_fcn(myplot,file1);
            if strcmp(graphicsfmt,'bmp')==1;
               set(myplot,'Visible','off');
            end;
            delete(myplot);
         end;
         if strcmp(graphicsfmt,'fig')==0;
            if mstat==0;
               if strcmp(computer,'PCWIN')==1;
                  program1 = [graphviewer ' ' file1 ' &'];
                  program1 = fixcmd(program1);
                  dos(program1);
               else;
                  if isunix==1;
                     program1 = [graphviewer ' ' file1];
                     unix(program1);
                  end;
               end;
            end;
         else;
            if mstat==0;
               openfig_fcn(file1);
               set(get(0,'CurrentFigure'),'Visible','on');
            else;
               text = strvcat(' ','MatLab''s figure format is not supported in stand-alone mode.');
               about(text,'information','Bad format...');
            end;
         end;
      end;
   end;
end;

%
% end of fitted_terms.m
%
