function [out,m_v,oldmodel_var] = main_openexo0_fcn(out,m_v,curr_ini,oldmodel_var,button_images,fig)

m_v.endofile = strtrim(get(out.endogenous,'String'));

if isempty(m_v.exo0file)==1;
   if strcmp(get(out.estimate,'Enable'),'off')==1;
      if matlabnumber>=6.0;
         file = {'*.txt;*.data;*.wk1;*.xls;*.mat;*.csv', 'Data Files (*.txt, *.data, *.wk1, *.xls, *.mat, *.csv)'; ...
              '*.txt;*.data', 'Text Files (*.txt, *.data)'; ...
              '*.mat', 'MatLab MAT Files (*.mat)'; ...
              '*.wk1', 'Lotus 1-2-3 Spreadsheets (*.wk1)'; ...
              '*.xls', 'Excel Spreadsheets (*.xls)'; ...
              '*.csv', 'Comma Separated Value Files (*.csv)'; ...
              '*.*', 'All Files (*.*)'};
      else;
         if (iscompiled==1)&(iswinnt==1)&(curr_ini.opendialog==1);
            basedir = pwd;
            file_fltr = 'Data Files (*.txt, *.data, *.wk1, *.mat, *.csv)|*.txt;*.data;*.wk1;*.mat;*.csv|Text Files (*.txt, *.data)|*.txt;*.data|MatLab MAT Files (*.mat)|*.mat|Lotus 1-2-3 Spreadsheets (*.wk1)|*.wk1|Comma Separated Value Files (*.csv)|*.csv|All Files (*.*)|*.*|';
            best_pos = 1;
            title_txt = 'Open';
         else;
            file = '*.txt;*.data;*.wk1;*.mat;*.csv';
         end;
      end;
   else;
      if matlabnumber>=6.0;
         file = [getpath(m_v.endofile) '*.txt;*.data;*.wk1;*.xls;*.mat;*.csv'];
      else;
         if (iscompiled==1)&(iswinnt==1)&(curr_ini.opendialog==1);
            basedir = getpath(m_v.endofile);
            file_fltr = 'Data Files (*.txt, *.data, *.wk1, *.mat, *.csv)|*.txt;*.data;*.wk1;*.mat;*.csv|Text Files (*.txt, *.data)|*.txt;*.data|MatLab MAT Files (*.mat)|*.mat|Lotus 1-2-3 Spreadsheets (*.wk1)|*.wk1|Comma Separated Value Files (*.csv)|*.csv|All Files (*.*)|*.*|';
            best_pos = 1;
            title_txt = 'Open';
         else;
            file = [getpath(m_v.endofile) '*.txt;*.data;*.wk1;*.mat;*.csv'];
         end;
      end;
   end;
else;
   if matlabnumber>=6.0;
      exo0type = [upper(strrep(getext(m_v.exo0file),'.','')) ' Files (*' getext(m_v.exo0file) ')'];
      file = {['*' getext(m_v.exo0file)], exo0type; ...
           '*.txt;*.data;*.wk1;*.xls;*.mat;*.csv', 'Data Files (*.txt, *.data, *.wk1, *.xls, *.mat, *.csv)'; ...
           '*.txt;*.data', 'Text Files (*.txt, *.data)'; ...
           '*.mat', 'MatLab MAT Files (*.mat)'; ...
           '*.wk1', 'Lotus 1-2-3 Spreadsheets (*.wk1)'; ...
           '*.xls', 'Excel Spreadsheets (*.xls)'; ...
           '*.csv', 'Comma Separated Value Files (*.csv)'; ...
           '*.*', 'All Files (*.*)'};
   else;
      if (iscompiled==1)&(iswinnt==1)&(curr_ini.opendialog==1);
         basedir = getpath(m_v.exo0file);
         file_fltr = 'Data Files (*.txt, *.data, *.wk1, *.mat, *.csv)|*.txt;*.data;*.wk1;*.mat;*.csv|Text Files (*.txt, *.data)|*.txt;*.data|MatLab MAT Files (*.mat)|*.mat|Lotus 1-2-3 Spreadsheets (*.wk1)|*.wk1|Comma Separated Value Files (*.csv)|*.csv|All Files (*.*)|*.*|';
         best_pos = 1;
         title_txt = 'Open';
      else;
         file = m_v.exo0file;
      end;
   end;
end;
if (iscompiled==1)&(iswinnt==1)&(curr_ini.opendialog==1)&(matlabnumber<6.0);
   [exogenous,exo0path] = fileopen(basedir,file_fltr,best_pos,title_txt);
else;
   if matlabnumber>=6;
      if strcmp(m_v.exo0file,'')==1;
         dfile = getpath(m_v.endofile);
      else;
         dfile = m_v.exo0file;
      end;
      [exogenous,exo0path] = uigetfile(file,'Open',dfile);
   else;
      [exogenous,exo0path] = uigetfile(file,'Open');
   end;
end;
drawnow;
%
if (isnumeric(exogenous)==0)&((strcmp(m_v.exo0file,[exo0path exogenous])==0)|(strcmp(getext(exogenous),'.mat')==1)|(strcmp(getext(exogenous),'.xls')==1));
   [n,filestatus,dt,m_v.exo0sheet,action] = loaddata(strcat(exo0path,exogenous));
   if (filestatus==1)&((strcmp(m_v.exo0sheet,oldmodel_var.exo0sheet)==0)|(isempty(m_v.exo0sheet)==1));
      m_v.exo0file = strcat(exo0path,exogenous);
      set(out.exogenous0,'String',m_v.exo0file);
      if (strcmp(m_v.exo0file,oldmodel_var.exo0file)==0)|(strcmp(m_v.exo0sheet,oldmodel_var.exo0sheet)==0);
         [newxvars0,mystatus] = readnames(m_v.exo0file,m_v.exo0sheet);
         if mystatus==1;
            checkvars = get(out.exo0names,'UserData');
            if strcmp(checkvars,newxvars0)==0;
               m_v.xvars0 = newxvars0;
               oldmodel_var.xvars0 = checkvars;
               set(out.exo0names,'UserData',m_v.xvars0);
            end;
         else;
            if strcmp(m_v.exo0file,oldmodel_var.exo0file)==0;
               oldmodel_var.xvars0 = m_v.xvars0;
               m_v.xvars0 = '';
               set(out.exo0names,'UserData',m_v.xvars0);
            end;
         end;
         set(out.store,'Enable','on');
         set(out.savemenu,'Enable','on');
      end;
      set(out.exo0names,'Enable','on');
      set(out.exo0namesmenu,'Enable','on');
      set(out.change_exo0names,'Enable','on','CData',button_images.rename);
      if strcmp(strtrim(m_v.xvars0),'')==1;
         set(out.exogenous0text,'String','Exogenous I(0) variables:  Not determined');
      else;
         set(out.exogenous0text,'String',['Exogenous I(0) variables:  ' m_v.xvars0]);
      end;
      if isempty(m_v.exo0sheet)==1;
         set(out.exo0sheettext,'String','Data sheet: None');
      else;
         set(out.exo0sheettext,'String',['Data sheet: ' m_v.exo0sheet]);
      end;
      set(out.exo0graphicsmenu,'Enable','on');
      set(fig,'UserData',out);
      set(out.lagexo,'Enable','on','Value',1);
      set(out.lagexotext,'Enable','on');
   elseif (filestatus==0)&(strcmp(action,'Cancel')==0);
      m_v.exo0sheet = oldmodel_var.exo0sheet;
      set(out.exogenous0,'String',m_v.exo0file);
      set(fig,'UserData',out);
      if (matlabnumber<6.0)&(strcmp(getext(exogenous),'.xls')==1)&(iscompiled==0);
         txt = ['The file you selected, ' exogenous ', is an Excel spreadsheet. It cannot be read by this version of Matlab.'];
      elseif (matlabnumber<6.0)&(strcmp(getext(exogenous),'.xls')==1)&(iscompiled==1);
         txt = ['The file you selected, ' exogenous ', is an Excel spreadsheet. It cannot be read since the stand-alone release compilation was based on MatLab version ' matlabversion '.'];
      else;
         txt = ['The file you selected, ' exogenous ', does not contain any numeric data.'];
      end;
      about(txt,'error','Bad data...',120,400);
   elseif (filestatus==-1)&(strcmp(action,'Cancel')==0);
      txt = ['The file you selected, ' exogenous ', has missing observations.'];
      about(txt,'error','Bad data...',120,400);
   elseif strcmp(action,'Cancel')==1;
      m_v.exo0sheet = oldmodel_var.exo0sheet;
      set(out.exogenous0,'String',m_v.exo0file);
      set(fig,'UserData',out);
   end;
end;
m_v.cointvalue = get(out.radiocoint,'Value');
m_v.newdeterselect(1,1) = get(out.uconstant,'Value');
m_v.newdeterselect(1,2) = get(out.rconstant,'Value');
m_v.newdeterselect(1,3) = get(out.utrend,'Value');
m_v.newdeterselect(1,4) = get(out.rtrend,'Value');
m_v.newmodeltype(1,1) = get(out.structural,'Value');
m_v.newmodeltype(1,2) = get(out.reduced,'Value');
m_v.newseasonal(1,1) = get(out.seasonal,'Value');
m_v.newseasonal(1,2) = get(out.noseasonal,'Value');
m_v.lagexo = 0;
modeldesc = getmodeldesc(m_v);
set(out.text,'String',modeldesc);

%
% end of main_openexo0_fcn.m
%
