function nonlin_max

%#function myfun
%A = [-1 -2 -2;1 2 2];
%b = [0;72];

%[x,fval,exitflag,output] = fmincon_fcn('myfun',10*ones(3,1),A,b);

p1 = 1;
p2 = 2;
waitbar = 1;
waitbartext = 'ML Estimation of B';
options = optimset('LargeScale','on','TolCon',1e-10,'TolX',1e-10,'TolFun',1.0e-10,'MaxIter',3500,'MaxFunEvals',100000,'GradObj','on','GradConstr','on');
[x,fval,exitflag,output,lambda,grad,hessian] = fmincon_fcn('myfun',[-1 1],[],[],[],[],[],[],'mycon',options,waitbar,waitbartext,p1,p2);

disp(x);

disp(fval);

[c,ceq] = mycon(x);

disp(c);
disp(ceq);

disp(exitflag);

disp(output.algorithm);
disp(output.iterations);
disp(output.funcCount);
disp(output.convergence);
disp(output.abort);

disp(grad);

[f,g,H] = myfun(x,p1,p2);

disp(g);

%disp(hessian);

%disp(H);




