function pointer_crosshair

h = get(0,'CurrentFigure');
toolbar = get(h,'UserData');


if (isempty(toolbar)==0)&(isstruct(toolbar)==1)&(isfield(toolbar,'addline')==1);
   if (strcmp(get(toolbar.addline,'State'),'on')==1)|(strcmp(get(toolbar.addarrow,'State'),'on')==1)|((isfield(toolbar,'rectangle')==1)&(strcmp(get(toolbar.rectangle,'State'),'on')==1))|(strcmp(get(toolbar.axes,'State'),'on')==1);
      cp = get(h,'CurrentPoint');
      set(h,'Pointer','crosshair');
      %
      % create a text object in lower left corner
      %
      if isfield(toolbar,'lineentry')==0;
         curr_ini = find_inisettings;
         toolbar.lineentry = uicontrol('Parent',h, ...
            'Units','pixels', ...
            'Position',[2 2 200 15], ...
            'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
            'Visible','off', ...
            'Style','text', ...
            'FontSize',curr_ini.gui_fontsize, ...
            'FontName',curr_ini.gui_fontname, ...
            'FontWeight',curr_ini.gui_fontweight, ...
            'FontAngle',curr_ini.gui_fontangle, ...
            'ForegroundColor',[0.8 0 0], ...
            'HorizontalAlignment','left', ...
            'String','');
         set(h,'UserData',toolbar);
      end;
      %
      % determine position relative to axes objects
      %
      if strcmp(get(h,'Pointer'),'crosshair')==1;
         myaxes = get(toolbar.print,'UserData');
         check_break = 0;
         set(toolbar.lineentry,'Visible','on');
         for i=1:size(myaxes,2);
            curr_axes = myaxes(1,i);
            old_axes_units = get(curr_axes,'Units');
            set(curr_axes,'Units','pixels');
            curr_pos = get(curr_axes,'Position');
            set(curr_axes,'Units',old_axes_units);
            if (cp(1)>=curr_pos(1)-5)&(cp(1)<=curr_pos(1)+curr_pos(3)+5)&(cp(2)>=curr_pos(2)-5)&(cp(2)<=curr_pos(2)+curr_pos(4)+5);
               ax_cp = get(curr_axes,'CurrentPoint');
               if get(curr_axes,'View')==[0 90];
                  %
                  % assume 2D graph
                  %
                  set(toolbar.lineentry,'String',['X: ' num2str(ax_cp(1,1),'%0.4f') '   Y: ' num2str(ax_cp(1,2),'%0.4f')]);
               else;
                  set(toolbar.lineentry,'String',['X: ' num2str((ax_cp(1,1)+ax_cp(2,1))/2,'%0.4f') '   Y: ' num2str((ax_cp(1,2)+ax_cp(2,2))/2,'%0.4f') '   Z: ' num2str((ax_cp(1,3)+ax_cp(2,3))/2,'%0.4f')]);
               end;
               check_break = 1;
               break;
            end;
         end;
         if check_break==0;
            set(toolbar.lineentry,'Visible','off');
         end;
      end;
   elseif strcmp(get(toolbar.freehand,'State'),'on')==1;
      set(h,'Pointer','custom','PointerShapeCData',pencil_pointer);
   end;
end;

%
% end of pointer_crosshair.m
%
