%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% LocalXTerminalMode %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%
function bool = LocalXTerminalMode()
%XTerminalMode True or False that MATLAB is running in terminal mode, 
% no X DISPLAY  on Unix.
bool = 0;
if ~( strcmp( computer, 'PCWIN' ) | strncmp( computer, 'MAC', 3 ) )
    if ~strcmp( get(0,'TerminalProtocol'), 'x' )
        bool = 1;
    end
end

%
% end of LocalXTerminalMode.m
%
