function  setpp_fcn( target, properties )
%SETPP Set all paper properties.
%	SPP( h, properties ) set property values of h from fields in properties structure.

%   Copyright 1984-2001 The MathWorks, Inc. 
%   $Revision: 1.3 $  $Date: 2001/04/15 11:59:47 $

if nargin ~= 2
    error('No target and/or properties.')
end

%maintain order, in case units were changed, and so mode ends up auto if that was the case
setset_fcn(target,'paperunits', properties.paperunits );
setset_fcn(target,'paperposition', properties.paperposition );
setset_fcn(target,'paperpositionmode', properties.paperpositionmode );
 
setset_fcn(target,'paperorientation', properties.paperorientation );
setset_fcn(target,'papertype', properties.papertype );

%Can't do this, yet
%setset_fcn(target,'papersize', properties.papersize );
