function toolbar_fcn(myaxes,show_light)

%
% input is a 1xy vector, y=1,2,4 (typically)
%

%#function toolbar_saveas_fcn toolbar_print_fcn toolbar_resize_fcn toolbar_edit_fcn toolbar_legend_fcn toolbar_box_fcn toolbar_rotate_default_fcn toolbar_show_hide_surface_fcn change_title_font change_xlabel_font change_ylabel_font change_zlabel_font change_title_color change_xlabel_color change_ylabel_color change_zlabel_color change_axes_font change_axes_color change_allaxes_color change_xaxes_color change_yaxes_color change_zaxes_color check_title_fcn check_xlabel_fcn check_ylabel_fcn check_zlabel_fcn toolbar_lock_fcn toolbar_zoomin_fcn toolbar_zoomout_fcn toolbar_addtext_fcn toolbar_addarrow_fcn toolbar_addline_fcn pointer_beam addtext_fcn pointer_crosshair check_text_fcn savetext_fcn change_text_color change_text_font check_text_fcn lines_color_fcn scatter_color_fcn addline_fcn update_line_fcn save_line_fcn pointer_rotate hand_pointer handdown_pointer change_axes_projection change_ambientlight_color check_axes_lines change_light_style change_light_position light_lock_fcn move_light_fcn delete_surface_fcn menu_freehand_fcn brighten fix_colormap record_3dmovie_fcn stretch_lines toolbar_rectangle_fcn update_rectangle_fcn addrectangle_fcn menu_show_hidden_fcn radio_fcn check_scatter_plot import_period_fcn axes_statistics_fcn nudge_fcn fix_xtix_fcn fix_ytix_fcn yscale_patch_fcn xscale_patch_fcn empty_axes toolbar_demean_fcn
%#function arrow_color_fcn change_arrow_length change_arrow_base change_arrow_tip change_arrow_width patch_color_fcn patch_facecolor_fcn patch_edgecolor_fcn change_patch_type change_patch_width menu_addtext_fcn menu_addarrow_fcn menu_addline_fcn menu_zoomin_fcn menu_zoomout_fcn change_arrow_tippos uimenu_check_fcn copy_subplot_fcn lines_type_fcn change_legend_color change_legend_text_color change_legend_font legend_lock_fcn view_graphics_fcn new_figure_fcn toolbar_name_fcn add_legend_fcn update_legend_fcn copy_line_fcn copy_patch_fcn paste_line_fcn paste_patch_fcn delete_line_patch_fcn delete_legend_fcn toolbar_addaxes_fcn addaxes_fcn update_axes_fcn save_axes_fcn delete_axes_fcn page_setup printpreview_fcn toolbar_colorbar_fcn delete_colorbar_fcn add_colorbar_fcn print_resize_legend_fcn pointer_zoomin pointer_zoomout rotate3d_fcn menu_rotate3d_fcn toolbar_rotate3d_fcn toolbar_addcolorbar_fcn show_hide_light change_light_color toolbar_renderer_fcn copy_surface_fcn paste_surface_fcn toolbar_freehand_fcn fix_plane_color movie_3d_fcn axes_motion reorder_legend_fcn menu_rectangle_fcn save_rectangle_fcn stretch_patch stretch_a_patch import_data_fcn pencil_pointer x_zeros_fcn y_zeros_fcn rescale_patch_fcn figeditor_about_fcn help_fcn killpid axes_alignment undofigure export_data_fcn toolbar_editdata_fcn toolbar_editname_fcn toolbar_save_fcn

if nargin==1;
   show_light = 'off';
end;

curr_ini = find_inisettings;

psprintenable = 'off';
if strcmp(curr_ini.psprint,'')==0;
   if appexist(curr_ini.psprint)==1;
      psprintenable = 'on';
   end;
end;

if curr_ini.box==1;
   boxstr = 'Hide Axes &Box';
else;
   boxstr = 'Show Axes &Box';
end;

%h = get(0,'CurrentFigure');
h = get(myaxes(1,1),'Parent');
set(h,'DeleteFcn','drawnow');

mypos = get(h,'Position');
width = mypos(1,3);
height = mypos(1,4);

%
% legend handles (if any)
%

mylegs = [];
for i=1:size(myaxes,2);
   mylegs = [mylegs get(myaxes(1,i),'UserData')];
end;

if isempty(mylegs)==1;
   legenable = 'off';
   leg_str = 'Hide &Legend';
else;
   legenable = 'on';
   if strcmp(get(mylegs(1,1),'Visible'),'off')==1;
      leg_str = 'Show &Legend';
   else;
      leg_str = 'Hide &Legend';
   end;
end;

%
% surface objects (if any)
%

mysurf = [];
mylines = [];
mypatches = [];
myleg_lines = [];
show_hide_surf = '';
x_zeros = zeros(size(myaxes));
y_zeros = zeros(size(myaxes));
for i=1:size(myaxes,2);
   %
   % Fix X-axis ticks if smaller than 1 and max is greater than 10
   %
   xtick = get(myaxes(1,i),'XTick');
   if size(xtick,2)>1;
      if (abs(max(xtick))>10)&(abs(min(xtick))>10);
         if xtick(1,2)-xtick(1,1)<1;
            min_xtick = ceil(min(get(myaxes(1,i),'XLim')));
            max_xtick = floor(max(get(myaxes(1,i),'XLim')));
            new_xtick = (min_xtick:1:max_xtick);
            set(myaxes(1,i),'XTick',new_xtick);
         end;
      end;
   end;
   %
   if curr_ini.ytick==1;
      fixytix(myaxes(1,i));
   end;
   if curr_ini.xtick==1;
      fixxtix(myaxes(1,i));
   end;
   %
   newsurf = findobj(myaxes(1,i),'Type','surface')';
   this_axes(1,i).allsurfaces = sort(newsurf);
   mysurf = [mysurf newsurf];
   fix_surf = [];
   if isempty(newsurf)==0;
      for j=1:size(newsurf,2);
         if isnumeric(get(newsurf(1,j),'UserData'))==1;
            if strcmp(get(newsurf(1,j),'Visible'),'on')==1;
               show_hide_surf = 'Hide &Plane';
               show_hide_ud = 1;
            else;
               show_hide_surf = 'Show &Plane';
               show_hide_ud = 0;
            end;
         else;
            fix_surf = [fix_surf newsurf(1,j)];
         end;
      end;
      if isempty(fix_surf)==1;
         show_hide_surf = '';
      end;
      newsurf = fix_surf;
   end;
   %
   % looking for lines
   %
   linehandles = findobj(myaxes(1,i),'Type','line')';
   delhandles = [];
   if isempty(linehandles)==0;
      %
      % Remove zero lines from linehandles
      %
      fixhandles = [];
      for j=1:size(linehandles,2);
         checkvec = get(linehandles(1,j),'YData');
         checkvec2 = sum(get(linehandles(1,j),'XData'));
         checkstyle = get(linehandles(1,j),'LineStyle');
         if (isalmostequal(checkvec,get(linehandles(1,j),'XData'))==1)|(((checkvec==zeros(size(checkvec,1),1))|(checkvec2==zeros(size(checkvec2,1),1)))&((strcmp(checkstyle,'none')==0)|(isempty(get(linehandles(1,j),'UserData'))==0))|(strcmp(get(linehandles(1,j),'Tag'),'light')==1));
            fixhandles = [fixhandles 0];
         else;
            fixhandles = [fixhandles 1];
         end;
         if checkvec==zeros(size(checkvec,1),1);
            x_zeros(1,i) = 1;
         end;
         if max(get(linehandles(1,j),'XData'))==min(get(linehandles(1,j),'XData'));
            y_zeros(1,i) = 1;
         end;
      end;
      delhandles = linehandles(fixhandles==0);
      linehandles = linehandles(fixhandles==1);
      if (size(linehandles,1)==0)|(size(linehandles,2)==0);
         linehandles = [];
      end;
   end;
   if isempty(linehandles)==0;
      myleg_lines = [myleg_lines findobj(get(myaxes(1,i),'UserData'),'Type','line')'];
   end;
   legendline = [];
   if isempty(get(myaxes(1,i),'UserData'))==0;
      legendline = findobj(get(myaxes(1,i),'UserData'),'Type','line')';
   end;
   this_axes(1,i).ud = get(get(myaxes(1,i),'UserData'),'UserData');
   this_axes(1,i).legendline = legendline;
   this_axes(1,i).line = linehandles;
   mylines = [mylines linehandles];
   patchhandles = findobj(myaxes(1,i),'Type','patch')';
   this_axes(1,i).patch = patchhandles;
   this_axes(1,i).surface = sort(newsurf);
   patchleg = [];
   if isempty(patchhandles)==0;
      patchleg = findobj(get(myaxes(1,i),'UserData'),'Type','patch')';
      this_axes(1,i).legendpatch = patchleg;
   end;
   mypatches = [mypatches patchhandles];
end;
%
% remove any plane surfaces
%
if isempty(mysurf)==0;
   use_surf = [];
   for i=1:size(mysurf,2);
      if ischar(get(mysurf(1,i),'UserData'))==1;
         use_surf = [use_surf mysurf(1,i)];
      end;
   end;
   mysurf = use_surf;
end;

%
% button images
%

mycons = getstoredimages;
if curr_ini.use_toolbar_bgcolor==1;
   bgcolor = (1/255)*(round(255*get(0,'defaultuicontrolbackgroundcolor'))-[8 4 8]);
   bgcolor(1) = max(0,bgcolor(1));
   bgcolor(2) = max(0,bgcolor(2));
   bgcolor(3) = max(0,bgcolor(3));
else;
   bgcolor = [NaN NaN NaN];
end;
mysaveas = maketrans(mycons.saveas_image,[160 160 164],bgcolor);
mysave = maketrans(mycons.save_image,[160 160 164],bgcolor);
myclose = maketrans(mycons.close_image,[160 160 164],bgcolor);
myprintenable = maketrans(mycons.print_image,[160 160 164],bgcolor);
myfreehand = maketrans(mycons.editgraph_image,[160 160 164],bgcolor);
myrectangle = maketrans(mycons.rectangle_image,[160 160 164],bgcolor);
my_moviestar = maketrans(mycons.moviestar_image,[160 160 164],bgcolor);
%my_rec_movie_horizontal = maketrans(mycons.rec_movie_horizontal_image,[160 160 164],bgcolor);
%my_rec_movie_vertical = maketrans(mycons.rec_movie_vertical_image,[160 160 164],bgcolor);
myeditgraph = maketrans(mycons.axesproperties_image,[160 160 164],bgcolor);
myzoominup = maketrans(mycons.zoomin_image,[160 160 164],bgcolor);
myzoomoutup = maketrans(mycons.zoomout_image,[160 160 164],bgcolor);
my_text = maketrans(mycons.text_image,[160 160 164],bgcolor);
my_arrow = maketrans(mycons.arrow_image,[160 160 164],bgcolor);
my_line = maketrans(mycons.line_image,[160 160 164],bgcolor);
my_new = maketrans(mycons.new_image,[160 160 164],bgcolor);
my_viewgraphics = maketrans(mycons.open_image,[160 160 164],bgcolor);
my_help = maketrans(mycons.help_image,[160 160 164],bgcolor);
my_axes = maketrans(mycons.axes_image,[160 160 164],bgcolor);
my_undo = maketrans(mycons.undo_image,[160 160 164],bgcolor);

if isempty(mysurf)==0;
   myrotate = maketrans(mycons.rotate_image,[160 160 164],bgcolor);
   myrotate3d_up = maketrans(mycons.rotate3d_image,[160 160 164],bgcolor);
end;

if ishandle(h)==1;
   set(h,'ResizeFcn','toolbar_resize_fcn');
   this_colorbar = findobj(h,'Type','axes','Tag','colorbar')';
   %
   % Find all text objects
   %
   this_axes_text_obj = [];
   for i=1:size(myaxes,2);
      %
      % create a context menu for axes objects
      %
      axes_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
         uimenu('Parent',axes_context_menu,'Label','Font','Callback','change_axes_font');
         uimenu('Parent',axes_context_menu,'Separator','on','Label','Background Color','Callback','change_axes_color');
      axes_color_menu = uimenu('Parent',axes_context_menu,'Label','Axes Color');
         uimenu('Parent',axes_color_menu,'Label','Axes Color','Callback','change_allaxes_color');
         uimenu('Parent',axes_color_menu,'Label','X Axis Color','Callback','change_xaxes_color');
         uimenu('Parent',axes_color_menu,'Label','Y Axis Color','Callback','change_yaxes_color');
      axes_width_menu = uimenu('Parent',axes_context_menu,'Label','Axes Width');
         pt0 = 'off';
         pt1 = 'off';
         pt2 = 'off';
         pt3 = 'off';
         pt4 = 'off';
         pt5 = 'off';
         pt6 = 'off';
         pt7 = 'off';
         pt8 = 'off';
         pt9 = 'off';
         pt10 = 'off';
         if get(myaxes(1,i),'LineWidth')==0.5;
            pt0 = 'on';
         elseif get(myaxes(1,i),'LineWidth')==1;
            pt1 = 'on';
         elseif get(myaxes(1,i),'LineWidth')==2;
            pt2 = 'on';
         elseif get(myaxes(1,i),'LineWidth')==3;
            pt3 = 'on';
         elseif get(myaxes(1,i),'LineWidth')==4;
            pt4 = 'on';
         elseif get(myaxes(1,i),'LineWidth')==5;
            pt5 = 'on';
         elseif get(myaxes(1,i),'LineWidth')==6;
            pt6 = 'on';
         elseif get(myaxes(1,i),'LineWidth')==7;
            pt7 = 'on';
         elseif get(myaxes(1,i),'LineWidth')==8;
            pt8 = 'on';
         elseif get(myaxes(1,i),'LineWidth')==9;
            pt9 = 'on';
         elseif get(myaxes(1,i),'LineWidth')==10;
            pt10 = 'on';
         end;
         uimenu('Parent',axes_width_menu,'Label','0.5 pt','Checked',pt0,'Callback','set(gca,''LineWidth'',0.5); check_axes_lines; uimenu_check_fcn');
         uimenu('Parent',axes_width_menu,'Label','1 pt','Checked',pt1,'Callback','set(gca,''LineWidth'',1); check_axes_lines; uimenu_check_fcn');
         uimenu('Parent',axes_width_menu,'Label','2 pts','Checked',pt2,'Callback','set(gca,''LineWidth'',2); check_axes_lines; uimenu_check_fcn');
         uimenu('Parent',axes_width_menu,'Label','3 pts','Checked',pt3,'Callback','set(gca,''LineWidth'',3); check_axes_lines; uimenu_check_fcn');
         uimenu('Parent',axes_width_menu,'Label','4 pts','Checked',pt4,'Callback','set(gca,''LineWidth'',4); check_axes_lines; uimenu_check_fcn');
         uimenu('Parent',axes_width_menu,'Label','5 pts','Checked',pt5,'Callback','set(gca,''LineWidth'',5); check_axes_lines; uimenu_check_fcn');
         uimenu('Parent',axes_width_menu,'Label','6 pts','Checked',pt6,'Callback','set(gca,''LineWidth'',6); check_axes_lines; uimenu_check_fcn');
         uimenu('Parent',axes_width_menu,'Label','7 pts','Checked',pt7,'Callback','set(gca,''LineWidth'',7); check_axes_lines; uimenu_check_fcn');
         uimenu('Parent',axes_width_menu,'Label','8 pts','Checked',pt8,'Callback','set(gca,''LineWidth'',8); check_axes_lines; uimenu_check_fcn');
         uimenu('Parent',axes_width_menu,'Label','9 pts','Checked',pt9,'Callback','set(gca,''LineWidth'',9); check_axes_lines; uimenu_check_fcn');
         uimenu('Parent',axes_width_menu,'Label','10 pts','Checked',pt10,'Callback','set(gca,''LineWidth'',10); check_axes_lines; uimenu_check_fcn');
      axes_grid_menu = uimenu('Parent',axes_context_menu,'Label','Grid Style');
         pt1 = 'off';
         pt2 = 'off';
         pt3 = 'off';
         pt4 = 'off';
         pt5 = 'off';
         if strcmp(get(myaxes(1,i),'GridLineStyle'),'-')==1;
            pt1 = 'on';
         elseif strcmp(get(myaxes(1,i),'GridLineStyle'),'--')==1;
            pt2 = 'on';
         elseif strcmp(get(myaxes(1,i),'GridLineStyle'),':')==1;
            pt3 = 'on';
         elseif strcmp(get(myaxes(1,i),'GridLineStyle'),'-.')==1;
            pt4 = 'on';
         elseif strcmp(get(myaxes(1,i),'GridLineStyle'),'none')==1;
            pt5 = 'on';
         end;
         uimenu('Parent',axes_grid_menu,'Label','Solid','Checked',pt1,'Callback','set(gca,''GridLineStyle'',''-''); uimenu_check_fcn');
         uimenu('Parent',axes_grid_menu,'Label','Dash','Checked',pt2,'Callback','set(gca,''GridLineStyle'',''--''); uimenu_check_fcn');
         uimenu('Parent',axes_grid_menu,'Label','Dot','Checked',pt3,'Callback','set(gca,''GridLineStyle'','':''); uimenu_check_fcn');
         uimenu('Parent',axes_grid_menu,'Label','Dash-Dot','Checked',pt4,'Callback','set(gca,''GridLineStyle'',''-.''); uimenu_check_fcn');
         uimenu('Parent',axes_grid_menu,'Label','None','Checked',pt5,'Callback','set(gca,''GridLineStyle'',''none''); uimenu_check_fcn');
      axes_tick_menu = uimenu('Parent',axes_context_menu,'Label','Tick Direction');
         if strcmp(get(myaxes(1,i),'TickDir'),'in')==1;
            uimenu('Parent',axes_tick_menu,'Label','In','Checked','on','Callback','set(gca,''TickDir'',''in''); uimenu_check_fcn');
            uimenu('Parent',axes_tick_menu,'Label','Out','Checked','off','Callback','set(gca,''TickDir'',''out''); uimenu_check_fcn');
         else;
            uimenu('Parent',axes_tick_menu,'Label','In','Checked','off','Callback','set(gca,''TickDir'',''in''); uimenu_check_fcn');
            uimenu('Parent',axes_tick_menu,'Label','Out','Checked','on','Callback','set(gca,''TickDir'',''out''); uimenu_check_fcn');
         end;
      axes_layer_menu = uimenu('Parent',axes_context_menu,'Label','Layer');
         if strcmp(get(myaxes(1,i),'Layer'),'bottom')==1;
            uimenu('Parent',axes_layer_menu,'Label','Bottom','Checked','on','Callback','set(gca,''Layer'',''bottom''); uimenu_check_fcn');
            uimenu('Parent',axes_layer_menu,'Label','Top','Checked','off','Callback','set(gca,''Layer'',''top''); uimenu_check_fcn');
         else;
            uimenu('Parent',axes_layer_menu,'Label','Bottom','Checked','off','Callback','set(gca,''Layer'',''bottom''); uimenu_check_fcn');
            uimenu('Parent',axes_layer_menu,'Label','Top','Checked','on','Callback','set(gca,''Layer'',''top''); uimenu_check_fcn');
         end;
      %
      if isempty(this_axes(1,i).surface)==0;
         uimenu('Parent',axes_color_menu,'Label','Z Axis Color','Callback','change_zaxes_color');
         axes_projection_menu = uimenu('Parent',axes_context_menu,'Label','Projection');
         if strcmp(get(myaxes(1,i),'Projection'),'orthographic')==1;
            uimenu('Parent',axes_projection_menu,'Label','Orthographic','Checked','on','Callback','change_axes_projection');
            uimenu('Parent',axes_projection_menu,'Label','Perspective','Checked','off','Callback','change_axes_projection');
         else;
            uimenu('Parent',axes_projection_menu,'Label','Orthographic','Checked','off','Callback','change_axes_projection');
            uimenu('Parent',axes_projection_menu,'Label','Perspective','Checked','on','Callback','change_axes_projection');
         end;
         axes_motion_menu = uimenu('Parent',axes_context_menu,'Label','Motion');
            uimenu('Parent',axes_motion_menu,'Label','Horizontal 360','Interruptible','off','Callback','axes_motion(1)');
            uimenu('Parent',axes_motion_menu,'Label','Vertical 360','Interruptible','off','Callback','axes_motion(0)');
            uimenu('Parent',axes_motion_menu,'Label','Joint 360','Interruptible','off','Callback','axes_motion(2)');
         uimenu('Parent',axes_context_menu,'Label','Ambient Light Color','Separator','on','Callback','change_ambientlight_color');
         uimenu('Parent',axes_context_menu,'Label','Light Color','Callback','change_light_color');
         axes_lightstyle_menu = uimenu('Parent',axes_context_menu,'Label','Light Style');
         my_light = findobj(myaxes(1,i),'Type','light')';
         if strcmp(get(my_light,'Style'),'infinite')==1;
            uimenu('Parent',axes_lightstyle_menu,'Label','Infinite','Checked','on','Callback','change_light_style');
            uimenu('Parent',axes_lightstyle_menu,'Label','Local','Checked','off','Callback','change_light_style');
         else;
            uimenu('Parent',axes_lightstyle_menu,'Label','Infinite','Checked','off','Callback','change_light_style');
            uimenu('Parent',axes_lightstyle_menu,'Label','Local','Checked','on','Callback','change_light_style');
         end;
         light_pos = get(my_light,'Position');
         light_line = findobj(myaxes(1,i),'Type','line','UserData','light')';
         if isempty(light_line)==1;
            light_line = line('XData',light_pos(1), ...
                            'YData',light_pos(2), ...
                            'ZData',light_pos(3), ...
                            'Parent',myaxes(1,i), ...
                            'UserData','light', ...
                            'Tag','light', ...
                            'Visible',show_light, ...
                            'LineStyle','-', ...
                            'LineWidth',1, ...
                            'Marker','o', ...
                            'MarkerEdgeColor',get(myaxes(1,i),'AmbientLightColor'), ...
                            'MarkerFaceColor',get(my_light,'Color'), ...
                            'MarkerSize',10);
         end;
         %
         % Link a context menu to the light_line object
         %
         light_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
         uimenu('Parent',light_context_menu,'Label','Ambient Light Color','Callback','change_ambientlight_color');
         uimenu('Parent',light_context_menu,'Label','Light Color','Callback','change_light_color');
         light_lightstyle_menu = uimenu('Parent',light_context_menu,'Label','Light Style');
         if strcmp(get(my_light,'Style'),'infinite')==1;
            uimenu('Parent',light_lightstyle_menu,'Label','Infinite','Checked','on','Callback','change_light_style');
            uimenu('Parent',light_lightstyle_menu,'Label','Local','Checked','off','Callback','change_light_style');
         else;
            uimenu('Parent',light_lightstyle_menu,'Label','Infinite','Checked','off','Callback','change_light_style');
            uimenu('Parent',light_lightstyle_menu,'Label','Local','Checked','on','Callback','change_light_style');
         end;
         uimenu('Parent',light_context_menu,'Label','Unlock Light','Separator','on','Callback','light_lock_fcn');
         set(light_line,'UIContextMenu',light_context_menu);
         axes_light_menu = uimenu('Parent',axes_context_menu,'Label','Light Visibility');
         if strcmp(get(light_line,'Visible'),'on')==1;
            uimenu('Parent',axes_light_menu,'Label','Hide','Checked','off','Callback','show_hide_light');
            uimenu('Parent',axes_light_menu,'Label','Show','Checked','on','Callback','show_hide_light');
         else;
            uimenu('Parent',axes_light_menu,'Label','Hide','Checked','on','Callback','show_hide_light');
            uimenu('Parent',axes_light_menu,'Label','Show','Checked','off','Callback','show_hide_light');
         end;
         %
         % determine current light position relative to surface
         %
         light_surf = get(my_light,'UserData');
         surf_pos1 = 'off';
         surf_pos2 = 'off';
         surf_pos3 = 'off';
         surf_pos4 = 'off';
         surf_pos5 = 'off';
         surf_pos6 = 'off';
         surf_pos7 = 'off';
         surf_pos8 = 'off';
         if [min(min(get(light_surf,'XData'))) min(min(get(light_surf,'YData'))) min(min(get(light_surf,'ZData')))]==light_pos;
            surf_pos1 = 'on';
         elseif [min(min(get(light_surf,'XData'))) min(min(get(light_surf,'YData'))) max(max(get(light_surf,'ZData')))]==light_pos;
            surf_pos2 = 'on';
         elseif [min(min(get(light_surf,'XData'))) max(max(get(light_surf,'YData'))) min(min(get(light_surf,'ZData')))]==light_pos;
            surf_pos3 = 'on';
         elseif [min(min(get(light_surf,'XData'))) max(max(get(light_surf,'YData'))) max(max(get(light_surf,'ZData')))]==light_pos;
            surf_pos4 = 'on';
         elseif [max(max(get(light_surf,'XData'))) min(min(get(light_surf,'YData'))) min(min(get(light_surf,'ZData')))]==light_pos;
            surf_pos5 = 'on';
         elseif [max(max(get(light_surf,'XData'))) min(min(get(light_surf,'YData'))) max(max(get(light_surf,'ZData')))]==light_pos;
            surf_pos6 = 'on';
         elseif [max(max(get(light_surf,'XData'))) max(max(get(light_surf,'YData'))) min(min(get(light_surf,'ZData')))]==light_pos;
            surf_pos7 = 'on';
         elseif [max(max(get(light_surf,'XData'))) max(max(get(light_surf,'YData'))) max(max(get(light_surf,'ZData')))]==light_pos;
            surf_pos8 = 'on';
         end;
         axes_lightposition_menu = uimenu('Parent',axes_context_menu,'Label','Light Position');
            uimenu('Parent',axes_lightposition_menu,'Label','min(X) max(Y) min(Z)','Checked',surf_pos3,'Callback','change_light_position');
            uimenu('Parent',axes_lightposition_menu,'Label','min(X) max(Y) max(Z)','Checked',surf_pos4,'Callback','change_light_position');
            uimenu('Parent',axes_lightposition_menu,'Label','min(X) min(Y) min(Z)','Checked',surf_pos1,'Callback','change_light_position');
            uimenu('Parent',axes_lightposition_menu,'Label','min(X) min(Y) max(Z)','Checked',surf_pos2,'Callback','change_light_position');
            uimenu('Parent',axes_lightposition_menu,'Label','max(X) min(Y) min(Z)','Checked',surf_pos5,'Callback','change_light_position');
            uimenu('Parent',axes_lightposition_menu,'Label','max(X) min(Y) max(Z)','Checked',surf_pos6,'Callback','change_light_position');
            uimenu('Parent',axes_lightposition_menu,'Label','max(X) max(Y) min(Z)','Checked',surf_pos7,'Callback','change_light_position');
            uimenu('Parent',axes_lightposition_menu,'Label','max(X) max(Y) max(Z)','Checked',surf_pos8,'Callback','change_light_position');
      else;
         axes_stretch_menu = uimenu('Parent',axes_context_menu,'Label','Stretch');
            uimenu('Parent',axes_stretch_menu,'Label','Horizontal Lines','Callback','stretch_lines(''h'')');
            uimenu('Parent',axes_stretch_menu,'Label','Vertical Lines','Callback','stretch_lines(''v'')');
            uimenu('Parent',axes_stretch_menu,'Label','45 Degree Lines','Callback','stretch_lines(''d'')');
            if isempty(mysurf)==1;
               uimenu('Parent',axes_stretch_menu,'Label','Rectangles Horizontally','Separator','on','Callback','stretch_patch(''h'')');
               uimenu('Parent',axes_stretch_menu,'Label','Rectangles Vertically','Callback','stretch_patch(''v'')');
            end;
         uimenu('Parent',axes_context_menu,'Separator','on','Label','Import Data','Callback','import_data_fcn');
         uimenu('Parent',axes_context_menu,'Label','Export Data','Callback','export_data_fcn');
         if isempty(get(myaxes(1,i),'Children'))==0;
            uimenu('Parent',axes_context_menu,'Separator','on','Enable','on','Label','Statistics','Callback','axes_statistics_fcn');
         else;
            uimenu('Parent',axes_context_menu,'Separator','on','Enable','off','Label','Statistics','Callback','axes_statistics_fcn');
         end;
      end;
      %
      % Deal with X and Y labels
      %
      if isempty(this_axes(1,i).surface)==1;
         %
         % check if we need to add Match Data Units functions
         %
         fix_y = 0;
         fix_x = 0;
         ytick = get(myaxes(1,i),'YTick');
         ylabels = get(myaxes(1,i),'YTickLabel');
         if isempty(ylabels)==0;
            if ((isalmostequal(mystr2num(strtrim(ylabels(1,:))),ytick(1,1))==0)|(isalmostequal(mystr2num(strtrim(ylabels(size(ylabels,1),:))),ytick(1,size(ytick,2)))==0))&(size(ytick,2)>=2);
               fix_y = 1;
            end;
         end;
         xtick = get(myaxes(1,i),'XTick');
         xlabels = get(myaxes(1,i),'XTickLabel');
         if isempty(xlabels)==0;
            if ((isalmostequal(mystr2num(strtrim(xlabels(1,:))),xtick(1,1))==0)|(isalmostequal(mystr2num(strtrim(xlabels(size(xlabels,1),:))),xtick(1,size(xtick,2)))==0))&(size(xtick,2)>=2);
               fix_x = 1;
            end;
         end;
         %
         % add controls if necessary
         %
         if (fix_x==1)|(fix_y==1)|(strcmp(get(myaxes(1,i),'XTickLabelMode'),'manual')==1)|(strcmp(get(myaxes(1,i),'YTickLabelMode'),'manual')==1);
            axes_tick_menu = uimenu('Parent',axes_context_menu,'Separator','on','label','Match Data Units');
            paste_sep = 'off';
         else;
            paste_sep = 'on';
         end;
         if fix_x==1;
            uimenu('Parent',axes_tick_menu,'Label','Match X Axis','Callback','fix_xtix_fcn');
         elseif strcmp(get(myaxes(1,i),'XTickLabelMode'),'manual')==1;
            uimenu('Parent',axes_tick_menu,'Label','Automatic X Axis Labels','Callback','fix_xtix_fcn');
         end;
         if fix_y==1;
            uimenu('Parent',axes_tick_menu,'Label','Match Y Axis','Callback','fix_ytix_fcn');
         elseif strcmp(get(myaxes(1,i),'YTickLabelMode'),'manual')==1;
            uimenu('Parent',axes_tick_menu,'Label','Automatic Y Axis Labels','Callback','fix_ytix_fcn');
         end;
      else;
         paste_sep = 'on';
      end;
      %
      % check for model.run userdata
      %
      aw_fix = findobj('Tag','StructuralVAR');
      model = get(aw_fix,'UserData');
      copy = get(model.run,'UserData');
      line_copy_enable = 'off';
      patch_copy_enable = 'off';
      surface_copy_enable = 'off';
      if isfield(copy,'line_properties')==1;
         line_copy_enable = 'on';
      end;
      if isfield(copy,'patch_properties')==1;
         patch_copy_enable = 'on';
      end;
      if isfield(copy,'surface_properties')==1;
         surface_copy_enable = 'on';
      end;
      curr_colorbar = [];
      if isempty(this_colorbar)==0;
         for j=1:size(this_colorbar,2);
            if get(this_colorbar(1,j),'UserData')==myaxes(1,i);
               curr_colorbar = this_colorbar(1,j);
               break;
            end;
         end;
      end;
      %
      axes_copy_menu = uimenu('Parent',axes_context_menu,'Separator',paste_sep,'label','Paste');
         uimenu('Parent',axes_copy_menu,'Label','Line','Enable',line_copy_enable,'Callback','paste_line_fcn');
         uimenu('Parent',axes_copy_menu,'Label','Patch','Enable',patch_copy_enable,'Callback','paste_patch_fcn');
         uimenu('Parent',axes_copy_menu,'Label','Surface','Enable',surface_copy_enable,'Callback','paste_surface_fcn');
      if (size(myaxes,2)>1)|((isempty(curr_colorbar)==0)&(ishandle(curr_colorbar)==1)&(strcmp(get(curr_colorbar,'Visible'),'on')==1));
         uimenu('Parent',axes_context_menu,'Label','Copy Subplot','Callback','copy_subplot_fcn');
      end;
      if (isempty(this_axes(1,i).surface)==1)&(x_zeros(1,i)==0);
         uimenu('Parent',axes_context_menu,'Label','Y Axis Zero Line','Callback','x_zeros_fcn');
      end;
      if (isempty(this_axes(1,i).surface)==1)&(y_zeros(1,i)==0);
         uimenu('Parent',axes_context_menu,'Label','X Axis Zero Line','Callback','y_zeros_fcn');
      end;
      %
      % check for legend
      %
      my_leg = find_legend(myaxes(1,i));
      if (isempty(my_leg)==1)&((isempty(this_axes(1,i).line)==0)|(isempty(this_axes(1,i).patch)==0)|(isempty(this_axes(1,i).surface)==0));
         uimenu('Parent',axes_context_menu,'Separator','on','Label','Add Legend','Callback','add_legend_fcn');
         if size(myaxes,2)>1;
            uimenu('Parent',axes_context_menu,'Label','Delete Axes','Callback','delete_axes_fcn');
         end;
      elseif (isempty(my_leg)==0)&((isempty(this_axes(1,i).line)==0)|(isempty(this_axes(1,i).patch)==0)|(isempty(this_axes(1,i).surface)==0));
         uimenu('Parent',axes_context_menu,'Separator','on','Label','Delete Legend','Callback','delete_legend_fcn');
         if size(myaxes,2)>1;
            uimenu('Parent',axes_context_menu,'Label','Delete Axes','Callback','delete_axes_fcn');
         end;
      else;
         if size(myaxes,2)>1;
            uimenu('Parent',axes_context_menu,'Label','Delete Axes','Separator','on','Callback','delete_axes_fcn');
         end;
      end;
      %
      uimenu('Parent',axes_context_menu,'Separator','on','Label','Unlock Axes','Callback','toolbar_lock_fcn');
      set(myaxes(1,i),'UIContextMenu',axes_context_menu);
      %
      % create a context menu for title object
      %
      title_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
      uimenu('Parent',title_context_menu,'Label','Edit','Callback','set(get(gca,''Title''),''Editing'',''on'')');
      uimenu('Parent',title_context_menu,'Separator','on','Label','Font','Callback','change_title_font');
      uimenu('Parent',title_context_menu,'Label','Font Color','Callback','change_title_color');
      set(get(myaxes(1,i),'Title'),'UIContextMenu',title_context_menu,'ButtonDownFcn','check_title_fcn');
      %
      % create a context menu for x-label
      %
      xlabel_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
      uimenu('Parent',xlabel_context_menu,'Label','Edit','Callback','set(get(gca,''XLabel''),''Editing'',''on'')');
      uimenu('Parent',xlabel_context_menu,'Separator','on','Label','Font','Callback','change_xlabel_font');
      uimenu('Parent',xlabel_context_menu,'Label','Font Color','Callback','change_xlabel_color');
      set(get(myaxes(1,i),'XLabel'),'UIContextMenu',xlabel_context_menu,'ButtonDownFcn','check_xlabel_fcn');
      %
      % create a context menu for y-label
      %
      ylabel_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
      uimenu('Parent',ylabel_context_menu,'Label','Edit','Callback','set(get(gca,''YLabel''),''Editing'',''on'')');
      uimenu('Parent',ylabel_context_menu,'Separator','on','Label','Font','Callback','change_ylabel_font');
      uimenu('Parent',ylabel_context_menu,'Label','Font Color','Callback','change_ylabel_color');
      set(get(myaxes(1,i),'YLabel'),'UIContextMenu',ylabel_context_menu,'ButtonDownFcn','check_ylabel_fcn');
      %
      % create a context menu for y-label
      %
      zlabel_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
      uimenu('Parent',zlabel_context_menu,'Label','Edit','Callback','set(get(gca,''ZLabel''),''Editing'',''on'')');
      uimenu('Parent',zlabel_context_menu,'Separator','on','Label','Font','Callback','change_zlabel_font');
      uimenu('Parent',zlabel_context_menu,'Label','Font Color','Callback','change_zlabel_color');
      set(get(myaxes(1,i),'ZLabel'),'UIContextMenu',zlabel_context_menu,'ButtonDownFcn','check_zlabel_fcn');
      %
      % Context menu for surfaces
      %
      if isempty(this_axes(1,i).allsurfaces)==0;
         check_surf = 0;
         surf_handle = [];
         for j=1:size(this_axes(1,i).allsurfaces,2);
            if isnumeric(get(this_axes(1,i).allsurfaces(1,j),'UserData'))==0;
               check_surf = 1;
               surf_handle = this_axes(1,i).allsurfaces(1,j);
               break;
            end;
         end;
         %
         % make sure all surfaces have the same context menu
         %
         if check_surf==1;
            for j=1:size(this_axes(1,i).allsurfaces,2);
               surface_context = toolbar_surface_context(surf_handle);
               set(this_axes(1,i).allsurfaces(1,j),'UIContextMenu',surface_context);
            end;
         else;
            for j=1:size(this_axes(1,i).allsurfaces,2);
               surface_context = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
               uimenu('Parent',surface_context,'label','Cut','Callback','delete_surface_fcn');
               set(this_axes(1,i).allsurfaces(1,j),'UIContextMenu',surface_context);
            end;
         end;
      end;
   end;
   %
   % create a context menu for lines
   %
   if isempty(mylines)==0;
      %
      % add legend line handle to userdata of line
      % and legend patch handle to userdata of patch
      %
      for i=1:size(myaxes,2);
         if isempty(this_axes(i).line)==0;
            if isempty(this_axes(i).ud)==0;
               this_leg_handles = this_axes(i).ud.handles';
               if size(this_leg_handles,1)>1;
                  this_leg_handles = this_leg_handles';
               end;
               for j=1:size(this_axes(i).line,2);
                  for i1=1:size(this_leg_handles,2);
                     if this_axes(i).line(1,j)==this_leg_handles(1,i1);
                        c_leg_lines = sort(this_axes(i).legendline);
                        for j1=1:size(c_leg_lines,2);
                           line_col = get(this_axes(i).line(1,j),'Color');
                           line_wid = get(this_axes(i).line(1,j),'LineWidth');
                           line_typ = get(this_axes(i).line(1,j),'LineStyle');
                           line_mark = get(this_axes(i).line(1,j),'Marker');
                           leg_col = get(c_leg_lines(1,j1),'Color');
                           leg_wid = get(c_leg_lines(1,j1),'LineWidth');
                           leg_typ = get(c_leg_lines(1,j1),'LineStyle');
                           leg_mark = get(c_leg_lines(1,j1),'Marker');
                           if (line_col==leg_col)&(line_wid==leg_wid)&(strcmp(line_typ,leg_typ)==1)&(strcmp(line_mark,leg_mark));
                              set(this_axes(i).line(1,j),'UserData',c_leg_lines(1,j1));
                              break;
                           end;
                        end;
                     end;
                  end;
               end;
            end;
         end;
      end;
      %
      % add the context menu to each line found in the graph
      %
      for j=1:size(mylines,2);
         if strcmp(get(mylines(1,j),'LineStyle'),'-')==1;
            solidon = 'on';
         else;
            solidon = 'off';
         end;
         if strcmp(get(mylines(1,j),'LineStyle'),'--')==1;
            dashon = 'on';
         else;
            dashon = 'off';
         end;
         if strcmp(get(mylines(1,j),'LineStyle'),':')==1;
            doton = 'on';
         else;
            doton = 'off';
         end;
         if strcmp(get(mylines(1,j),'LineStyle'),'-.')==1;
            dashdoton = 'on';
         else;
            dashdoton = 'off';
         end;
         if strcmp(get(mylines(1,j),'LineStyle'),'none')==1;
            noneon = 'on';
         else;
            noneon = 'off';
         end;
         tag_str = get(mylines(1,j),'Tag');
         if size(tag_str,2)>=8;
            tag_str = tag_str(1,1:8);
         end;
         tag_str = strtrim(tag_str);
         lines_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
         if strcmp(tag_str,'scatter-')==0;
            uimenu('Parent',lines_context_menu,'Label','Color','Callback','lines_color_fcn');
            line_type_menu = uimenu('Parent',lines_context_menu,'Separator','on','Label','Type');
               uimenu('Parent',line_type_menu,'Label','Solid','Checked',solidon,'Callback','set(gco,''LineStyle'',''-''); lines_type_fcn; uimenu_check_fcn');
               uimenu('Parent',line_type_menu,'Label','Dash','Checked',dashon,'Callback','set(gco,''LineStyle'',''--''); lines_type_fcn; uimenu_check_fcn');
               uimenu('Parent',line_type_menu,'Label','Dot','Checked',doton,'Callback','set(gco,''LineStyle'','':''); lines_type_fcn; uimenu_check_fcn');
               uimenu('Parent',line_type_menu,'Label','Dash-Dot','Checked',dashdoton,'Callback','set(gco,''LineStyle'',''-.''); lines_type_fcn; uimenu_check_fcn');
               uimenu('Parent',line_type_menu,'Label','None','Checked',noneon,'Callback','set(gco,''LineStyle'',''none''); lines_type_fcn; uimenu_check_fcn');
            pt1 = 'off';
            pt2 = 'off';
            pt3 = 'off';
            pt4 = 'off';
            pt5 = 'off';
            pt6 = 'off';
            pt7 = 'off';
            pt8 = 'off';
            pt9 = 'off';
            pt10 = 'off';
            if get(mylines(1,j),'LineWidth')==1;
               pt1 = 'on';
            elseif get(mylines(1,j),'LineWidth')==2;
               pt2 = 'on';
            elseif get(mylines(1,j),'LineWidth')==3;
               pt3 = 'on';
            elseif get(mylines(1,j),'LineWidth')==4;
               pt4 = 'on';
            elseif get(mylines(1,j),'LineWidth')==5;
               pt5 = 'on';
            elseif get(mylines(1,j),'LineWidth')==6;
               pt6 = 'on';
            elseif get(mylines(1,j),'LineWidth')==7;
               pt7 = 'on';
            elseif get(mylines(1,j),'LineWidth')==8;
               pt8 = 'on';
            elseif get(mylines(1,j),'LineWidth')==9;
               pt9 = 'on';
            elseif get(mylines(1,j),'LineWidth')==10;
               pt10 = 'on';
            end;
            line_width_menu = uimenu('Parent',lines_context_menu,'Label','Width');
               uimenu('Parent',line_width_menu,'Label','1 pt','Checked',pt1,'Callback','set(gco,''LineWidth'',1); lines_type_fcn; uimenu_check_fcn');
               uimenu('Parent',line_width_menu,'Label','2 pts','Checked',pt2,'Callback','set(gco,''LineWidth'',2); lines_type_fcn; uimenu_check_fcn');
               uimenu('Parent',line_width_menu,'Label','3 pts','Checked',pt3,'Callback','set(gco,''LineWidth'',3); lines_type_fcn; uimenu_check_fcn');
               uimenu('Parent',line_width_menu,'Label','4 pts','Checked',pt4,'Callback','set(gco,''LineWidth'',4); lines_type_fcn; uimenu_check_fcn');
               uimenu('Parent',line_width_menu,'Label','5 pts','Checked',pt5,'Callback','set(gco,''LineWidth'',5); lines_type_fcn; uimenu_check_fcn');
               uimenu('Parent',line_width_menu,'Label','6 pts','Checked',pt6,'Callback','set(gco,''LineWidth'',6); lines_type_fcn; uimenu_check_fcn');
               uimenu('Parent',line_width_menu,'Label','7 pts','Checked',pt7,'Callback','set(gco,''LineWidth'',7); lines_type_fcn; uimenu_check_fcn');
               uimenu('Parent',line_width_menu,'Label','8 pts','Checked',pt8,'Callback','set(gco,''LineWidth'',8); lines_type_fcn; uimenu_check_fcn');
               uimenu('Parent',line_width_menu,'Label','9 pts','Checked',pt9,'Callback','set(gco,''LineWidth'',9); lines_type_fcn; uimenu_check_fcn');
               uimenu('Parent',line_width_menu,'Label','10 pts','Checked',pt10,'Callback','set(gco,''LineWidth'',10); lines_type_fcn; uimenu_check_fcn');
            sep_str = 'off';
         else;
            uimenu('Parent',lines_context_menu,'Label','Color','Callback','scatter_color_fcn');
            sep_str = 'on';
         end;
         mark_none = 'off';
         mark_plus = 'off';
         mark_circle = 'off';
         mark_asterisk = 'off';
         mark_point = 'off';
         mark_cross = 'off';
         mark_square = 'off';
         mark_diamond = 'off';
         mark_up = 'off';
         mark_down = 'off';
         mark_right = 'off';
         mark_left = 'off';
         mark_pentagram = 'off';
         mark_hexagram = 'off';
         if strcmp(get(mylines(1,j),'Marker'),'none')==1;
            mark_none = 'on';
         elseif strcmp(get(mylines(1,j),'Marker'),'+')==1;
            mark_plus = 'on';
         elseif strcmp(get(mylines(1,j),'Marker'),'o')==1;
            mark_circle = 'on';
         elseif strcmp(get(mylines(1,j),'Marker'),'*')==1;
            mark_asterisk = 'on';
         elseif strcmp(get(mylines(1,j),'Marker'),'.')==1;
            mark_point = 'on';
         elseif strcmp(get(mylines(1,j),'Marker'),'x')==1;
            mark_cross = 'on';
         elseif strcmp(get(mylines(1,j),'Marker'),'s')==1;
            mark_square = 'on';
         elseif strcmp(get(mylines(1,j),'Marker'),'d')==1;
            mark_diamond = 'on';
         elseif strcmp(get(mylines(1,j),'Marker'),'^')==1;
            mark_up = 'on';
         elseif strcmp(get(mylines(1,j),'Marker'),'v')==1;
            mark_down = 'on';
         elseif strcmp(get(mylines(1,j),'Marker'),'>')==1;
            mark_right = 'on';
         elseif strcmp(get(mylines(1,j),'Marker'),'<')==1;
            mark_left = 'on';
         elseif strcmp(get(mylines(1,j),'Marker'),'p')==1;
            mark_pentagram = 'on';
         elseif strcmp(get(mylines(1,j),'Marker'),'h')==1;
            mark_hexagram = 'on';
         end;
         line_marker_menu = uimenu('Parent',lines_context_menu,'Label','Marker','Separator',sep_str);
            if strcmp(tag_str,'scatter-')==0;
               uimenu('Parent',line_marker_menu,'Label','none','Checked',mark_none,'Callback','set(gco,''Marker'',''none''); lines_type_fcn; uimenu_check_fcn');
            end;
            uimenu('Parent',line_marker_menu,'Label','plus sign','Checked',mark_plus,'Callback','set(gco,''Marker'',''+''); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_marker_menu,'Label','circle','Checked',mark_circle,'Callback','set(gco,''Marker'',''o''); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_marker_menu,'Label','asterisk','Checked',mark_asterisk,'Callback','set(gco,''Marker'',''*''); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_marker_menu,'Label','point','Checked',mark_point,'Callback','set(gco,''Marker'',''.''); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_marker_menu,'Label','cross','Checked',mark_cross,'Callback','set(gco,''Marker'',''x''); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_marker_menu,'Label','square','Checked',mark_square,'Callback','set(gco,''Marker'',''s''); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_marker_menu,'Label','diamond','Checked',mark_diamond,'Callback','set(gco,''Marker'',''d''); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_marker_menu,'Label','up triangle','Checked',mark_up,'Callback','set(gco,''Marker'',''^''); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_marker_menu,'Label','down triangle','Checked',mark_down,'Callback','set(gco,''Marker'',''v''); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_marker_menu,'Label','right triangle','Checked',mark_right,'Callback','set(gco,''Marker'',''>''); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_marker_menu,'Label','left triangle','Checked',mark_left,'Callback','set(gco,''Marker'',''<''); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_marker_menu,'Label','pentagram','Checked',mark_pentagram,'Callback','set(gco,''Marker'',''p''); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_marker_menu,'Label','hexagram','Checked',mark_hexagram,'Callback','set(gco,''Marker'',''h''); lines_type_fcn; uimenu_check_fcn');
         pt1 = 'off';
         pt2 = 'off';
         pt3 = 'off';
         pt4 = 'off';
         pt5 = 'off';
         pt6 = 'off';
         pt7 = 'off';
         pt8 = 'off';
         pt9 = 'off';
         pt10 = 'off';
         pt11 = 'off';
         pt12 = 'off';
         pt13 = 'off';
         pt14 = 'off';
         pt15 = 'off';
         pt16 = 'off';
         if get(mylines(1,j),'MarkerSize')==1;
            pt1 = 'on';
         elseif get(mylines(1,j),'MarkerSize')==2;
            pt2 = 'on';
         elseif get(mylines(1,j),'MarkerSize')==3;
            pt3 = 'on';
         elseif get(mylines(1,j),'MarkerSize')==4;
            pt4 = 'on';
         elseif get(mylines(1,j),'MarkerSize')==5;
            pt5 = 'on';
         elseif get(mylines(1,j),'MarkerSize')==6;
            pt6 = 'on';
         elseif get(mylines(1,j),'MarkerSize')==7;
            pt7 = 'on';
         elseif get(mylines(1,j),'MarkerSize')==8;
            pt8 = 'on';
         elseif get(mylines(1,j),'MarkerSize')==9;
            pt9 = 'on';
         elseif get(mylines(1,j),'MarkerSize')==10;
            pt10 = 'on';
         elseif get(mylines(1,j),'MarkerSize')==11;
            pt11 = 'on';
         elseif get(mylines(1,j),'MarkerSize')==12;
            pt12 = 'on';
         elseif get(mylines(1,j),'MarkerSize')==13;
            pt13 = 'on';
         elseif get(mylines(1,j),'MarkerSize')==14;
            pt14 = 'on';
         elseif get(mylines(1,j),'MarkerSize')==15;
            pt15 = 'on';
         elseif get(mylines(1,j),'MarkerSize')==16;
            pt16 = 'on';
         end;
         line_markersize_menu = uimenu('Parent',lines_context_menu,'Label','Marker Size');
            uimenu('Parent',line_markersize_menu,'Label','1 pt','Checked',pt1,'Callback','set(gco,''MarkerSize'',1); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_markersize_menu,'Label','2 pts','Checked',pt2,'Callback','set(gco,''MarkerSize'',2); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_markersize_menu,'Label','3 pts','Checked',pt3,'Callback','set(gco,''MarkerSize'',3); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_markersize_menu,'Label','4 pts','Checked',pt4,'Callback','set(gco,''MarkerSize'',4); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_markersize_menu,'Label','5 pts','Checked',pt5,'Callback','set(gco,''MarkerSize'',5); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_markersize_menu,'Label','6 pts','Checked',pt6,'Callback','set(gco,''MarkerSize'',6); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_markersize_menu,'Label','7 pts','Checked',pt7,'Callback','set(gco,''MarkerSize'',7); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_markersize_menu,'Label','8 pts','Checked',pt8,'Callback','set(gco,''MarkerSize'',8); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_markersize_menu,'Label','9 pts','Checked',pt9,'Callback','set(gco,''MarkerSize'',9); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_markersize_menu,'Label','10 pts','Checked',pt10,'Callback','set(gco,''MarkerSize'',10); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_markersize_menu,'Label','11 pts','Checked',pt11,'Callback','set(gco,''MarkerSize'',11); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_markersize_menu,'Label','12 pts','Checked',pt12,'Callback','set(gco,''MarkerSize'',12); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_markersize_menu,'Label','13 pts','Checked',pt13,'Callback','set(gco,''MarkerSize'',13); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_markersize_menu,'Label','14 pts','Checked',pt14,'Callback','set(gco,''MarkerSize'',14); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_markersize_menu,'Label','15 pts','Checked',pt15,'Callback','set(gco,''MarkerSize'',15); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_markersize_menu,'Label','16 pts','Checked',pt16,'Callback','set(gco,''MarkerSize'',16); lines_type_fcn; uimenu_check_fcn');
         line_tag = get(mylines(1,j),'Tag');
         if size(line_tag,2)>=8;
            line_tag = line_tag(1,1:8);
         end;
         if strcmp(line_tag,'3dlines-')==0;
            uimenu('Parent',lines_context_menu,'Separator','on','Label','Edit Data','Callback','toolbar_editdata_fcn');
            uimenu('Parent',lines_context_menu,'Label','Edit Name','Callback','toolbar_editname_fcn');
            if islinetimeseries(mylines(1,j))==1;
               uimenu('Parent',lines_context_menu,'Separator','on','Label','De-Mean','Callback','toolbar_demean_fcn');
            end;
         end;
         uimenu('Parent',lines_context_menu,'Separator','on','Label','Cut','Callback','delete_line_patch_fcn');
         uimenu('Parent',lines_context_menu,'Label','Copy','Callback','copy_line_fcn');
         set(mylines(1,j),'UIContextMenu',lines_context_menu);
      end;
   end;
   %
   % create a context menu for patches
   %
   if isempty(mypatches)==0;
      for i=1:size(myaxes,2);
         if isempty(this_axes(i).patch)==0;
            if isempty(this_axes(i).ud)==0;
               this_leg_handles = this_axes(i).ud.handles';
               if size(this_leg_handles,1)>1;
                  this_leg_handles = this_leg_handles';
               end;
               for j=1:size(this_axes(i).patch,2);
                  for i1=1:size(this_leg_handles,2);
                     if this_axes(i).patch(1,j)==this_leg_handles(1,i1);
                        c_leg_patch = sort(this_axes(i).legendpatch);
                        for j1=1:size(c_leg_patch,2);
                           patch_edgecol = get(this_axes(i).patch(1,j),'EdgeColor');
                           patch_facecol = get(this_axes(i).patch(1,j),'FaceColor');
                           patch_wid = get(this_axes(i).patch(1,j),'LineWidth');
                           patch_typ = get(this_axes(i).patch(1,j),'LineStyle');
                           patch_mark = get(this_axes(i).patch(1,j),'Marker');
                           leg_edgecol = get(c_leg_patch(1,j1),'EdgeColor');
                           leg_facecol = get(c_leg_patch(1,j1),'FaceColor');
                           leg_wid = get(c_leg_patch(1,j1),'LineWidth');
                           leg_typ = get(c_leg_patch(1,j1),'LineStyle');
                           leg_mark = get(c_leg_patch(1,j1),'Marker');
                           if (patch_edgecol==leg_edgecol)&(patch_facecol==leg_facecol)&(patch_wid==leg_wid)&(strcmp(patch_typ,leg_typ)==1)&(strcmp(patch_mark,leg_mark)==1);
                              set(this_axes(i).patch(1,j),'UserData',c_leg_patch(1,j1));
                              break;
                           end;
                        end;
                     end;
                  end;
               end;
            end;
         end;
      end;
      for j=1:size(mypatches,2);
         patch_tag = get(mypatches(1,j),'Tag');
         if size(patch_tag,2)>=9;
            patch_tag = patch_tag(1,1:9);
         else;
            patch_tag = '';
         end;
         if strcmp(patch_tag,'varpatch-')==0;
            patches_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
            uimenu('Parent',patches_context_menu,'Label','Patch Color','Callback','patch_color_fcn');
            uimenu('Parent',patches_context_menu,'Label','Edge Color','Callback','patch_edgecolor_fcn');
            uimenu('Parent',patches_context_menu,'Label','Face Color','Callback','patch_facecolor_fcn');
            if strcmp(get(mypatches(1,j),'LineStyle'),'-')==1;
               solidon = 'on';
            else;
               solidon = 'off';
            end;
            if strcmp(get(mypatches(1,j),'LineStyle'),'--')==1;
               dashon = 'on';
            else;
               dashon = 'off';
            end;
            if strcmp(get(mypatches(1,j),'LineStyle'),':')==1;
               doton = 'on';
            else;
               doton = 'off';
            end;
            if strcmp(get(mypatches(1,j),'LineStyle'),'-.')==1;
               dashdoton = 'on';
            else;
               dashdoton = 'off';
            end;
            patch_type_menu = uimenu('Parent',patches_context_menu,'Separator','on','Label','Type');
               uimenu('Parent',patch_type_menu,'Label','Solid','Checked',solidon,'Callback','change_patch_type(''-''); uimenu_check_fcn');
               uimenu('Parent',patch_type_menu,'Label','Dash','Checked',dashon,'Callback','change_patch_type(''--''); uimenu_check_fcn');
               uimenu('Parent',patch_type_menu,'Label','Dot','Checked',doton,'Callback','change_patch_type('':''); uimenu_check_fcn');
               uimenu('Parent',patch_type_menu,'Label','Dash-Dot','Checked',dashdoton,'Callback','change_patch_type(''-.''); uimenu_check_fcn');
            pt1 = 'off';
            pt2 = 'off';
            pt3 = 'off';
            pt4 = 'off';
            pt5 = 'off';
            pt6 = 'off';
            pt7 = 'off';
            pt8 = 'off';
            pt9 = 'off';
            pt10 = 'off';
            if get(mypatches(1,j),'LineWidth')==1;
               pt1 = 'on';
            elseif get(mypatches(1,j),'LineWidth')==2;
               pt2 = 'on';
            elseif get(mypatches(1,j),'LineWidth')==3;
               pt3 = 'on';
            elseif get(mypatches(1,j),'LineWidth')==4;
               pt4 = 'on';
            elseif get(mypatches(1,j),'LineWidth')==5;
               pt5 = 'on';
            elseif get(mypatches(1,j),'LineWidth')==6;
               pt6 = 'on';
            elseif get(mypatches(1,j),'LineWidth')==7;
               pt7 = 'on';
            elseif get(mypatches(1,j),'LineWidth')==8;
               pt8 = 'on';
            elseif get(mypatches(1,j),'LineWidth')==9;
               pt9 = 'on';
            elseif get(mypatches(1,j),'LineWidth')==10;
               pt10 = 'on';
            end;
            patch_width_menu = uimenu('Parent',patches_context_menu,'Label','Width');
               uimenu('Parent',patch_width_menu,'Label','1 pt','Checked',pt1,'Callback','change_patch_width(1); uimenu_check_fcn');
               uimenu('Parent',patch_width_menu,'Label','2 pts','Checked',pt2,'Callback','change_patch_width(2); uimenu_check_fcn');
               uimenu('Parent',patch_width_menu,'Label','3 pts','Checked',pt3,'Callback','change_patch_width(3); uimenu_check_fcn');
               uimenu('Parent',patch_width_menu,'Label','4 pts','Checked',pt4,'Callback','change_patch_width(4); uimenu_check_fcn');
               uimenu('Parent',patch_width_menu,'Label','5 pts','Checked',pt5,'Callback','change_patch_width(5); uimenu_check_fcn');
               uimenu('Parent',patch_width_menu,'Label','6 pts','Checked',pt6,'Callback','change_patch_width(6); uimenu_check_fcn');
               uimenu('Parent',patch_width_menu,'Label','7 pts','Checked',pt7,'Callback','change_patch_width(7); uimenu_check_fcn');
               uimenu('Parent',patch_width_menu,'Label','8 pts','Checked',pt8,'Callback','change_patch_width(8); uimenu_check_fcn');
               uimenu('Parent',patch_width_menu,'Label','9 pts','Checked',pt9,'Callback','change_patch_width(9); uimenu_check_fcn');
               uimenu('Parent',patch_width_menu,'Label','10 pts','Checked',pt10,'Callback','change_patch_width(10); uimenu_check_fcn');
            if (strcmp(lower(get(mypatches(1,j),'Tag')),'rectpatch')==1)|(strcmp(lower(get(mypatches(1,j),'Tag')),'rectpatch-new')==1);
               uimenu('Parent',patches_context_menu,'Separator','on','Label','Stretch Horizontally','Callback','stretch_a_patch(''h'')');
               uimenu('Parent',patches_context_menu,'Label','Stretch Vertically','Callback','stretch_a_patch(''v'')');
               uimenu('Parent',patches_context_menu,'Label','Adjust X-scale to X axis limits','Callback','xscale_patch_fcn');
               uimenu('Parent',patches_context_menu,'Label','Adjust Y-scale to Y axis limits','Callback','yscale_patch_fcn');
            else;
               nudge_menu = uimenu('Parent',patches_context_menu,'Label','Nudge','Separator','on');
                  uimenu('Parent',nudge_menu,'Label','Up','Callback','nudge_fcn(''u'')');
                  uimenu('Parent',nudge_menu,'Label','Down','Callback','nudge_fcn(''d'')');
                  uimenu('Parent',nudge_menu,'Label','Left','Callback','nudge_fcn(''l'')');
                  uimenu('Parent',nudge_menu,'Label','Right','Callback','nudge_fcn(''r'')');
               rescale_menu = uimenu('Parent',patches_context_menu,'Label','Rescale');
                  uimenu('Parent',rescale_menu,'Label','10%','Callback','rescale_patch_fcn(0.1)');
                  uimenu('Parent',rescale_menu,'Label','20%','Callback','rescale_patch_fcn(0.2)');
                  uimenu('Parent',rescale_menu,'Label','25%','Callback','rescale_patch_fcn(0.25)');
                  uimenu('Parent',rescale_menu,'Label','30%','Callback','rescale_patch_fcn(0.3)');
                  uimenu('Parent',rescale_menu,'Label','40%','Callback','rescale_patch_fcn(0.4)');
                  uimenu('Parent',rescale_menu,'Label','50%','Callback','rescale_patch_fcn(0.5)');
                  uimenu('Parent',rescale_menu,'Label','60%','Callback','rescale_patch_fcn(0.6)');
                  uimenu('Parent',rescale_menu,'Label','70%','Callback','rescale_patch_fcn(0.7)');
                  uimenu('Parent',rescale_menu,'Label','75%','Callback','rescale_patch_fcn(0.75)');
                  uimenu('Parent',rescale_menu,'Label','80%','Callback','rescale_patch_fcn(0.8)');
                  uimenu('Parent',rescale_menu,'Label','90%','Callback','rescale_patch_fcn(0.9)');
                  uimenu('Parent',rescale_menu,'Label','110%','Callback','rescale_patch_fcn(1.1)');
                  uimenu('Parent',rescale_menu,'Label','120%','Callback','rescale_patch_fcn(1.2)');
                  uimenu('Parent',rescale_menu,'Label','125%','Callback','rescale_patch_fcn(1.25)');
                  uimenu('Parent',rescale_menu,'Label','130%','Callback','rescale_patch_fcn(1.3)');
                  uimenu('Parent',rescale_menu,'Label','140%','Callback','rescale_patch_fcn(1.4)');
                  uimenu('Parent',rescale_menu,'Label','150%','Callback','rescale_patch_fcn(1.5)');
                  uimenu('Parent',rescale_menu,'Label','160%','Callback','rescale_patch_fcn(1.6)');
                  uimenu('Parent',rescale_menu,'Label','170%','Callback','rescale_patch_fcn(1.7)');
                  uimenu('Parent',rescale_menu,'Label','180%','Callback','rescale_patch_fcn(1.8)');
                  uimenu('Parent',rescale_menu,'Label','190%','Callback','rescale_patch_fcn(1.9)');
                  uimenu('Parent',rescale_menu,'Label','200%','Callback','rescale_patch_fcn(2.0)');
                  uimenu('Parent',rescale_menu,'Label','250%','Callback','rescale_patch_fcn(2.5)');
                  uimenu('Parent',rescale_menu,'Label','300%','Callback','rescale_patch_fcn(3.0)');
                  uimenu('Parent',rescale_menu,'Label','400%','Callback','rescale_patch_fcn(4.0)');
                  uimenu('Parent',rescale_menu,'Label','500%','Callback','rescale_patch_fcn(5.0)');
                  uimenu('Parent',rescale_menu,'Label','1000%','Callback','rescale_patch_fcn(10.0)');
            end;
            uimenu('Parent',patches_context_menu,'Separator','on','Label','Edit Data','Callback','toolbar_editdata_fcn');
            if isvalidpatchname(mypatches(1,j))==1;
               uimenu('Parent',patches_context_menu,'Label','Edit Name','Callback','toolbar_editname_fcn');
            end;
            uimenu('Parent',patches_context_menu,'Separator','on','Label','Cut','Callback','delete_line_patch_fcn');
            uimenu('Parent',patches_context_menu,'Label','Copy','Callback','copy_patch_fcn');
            set(mypatches(1,j),'UIContextMenu',patches_context_menu);
         else;
            %
            % create a context menu for arrows
            %
            arrow_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
            uimenu('Parent',arrow_context_menu,'Label','Color','Callback','arrow_color_fcn');
            %
            % read user data
            %
            ud = get(mypatches(1,j),'UserData');
            len4 = 'off';
            len5 = 'off';
            len6 = 'off';
            len7 = 'off';
            len8 = 'off';
            len9 = 'off';
            len10 = 'off';
            len11 = 'off';
            len12 = 'off';
            len13 = 'off';
            len14 = 'off';
            len15 = 'off';
            len16 = 'off';
            len17 = 'off';
            len18 = 'off';
            len19 = 'off';
            len20 = 'off';
            len21 = 'off';
            len22 = 'off';
            len23 = 'off';
            len24 = 'off';
            len25 = 'off';
            len26 = 'off';
            len27 = 'off';
            len28 = 'off';
            len29 = 'off';
            len30 = 'off';
            if ud(7)==4;
               len4 = 'on';
            elseif ud(7)==5;
               len5 = 'on';
            elseif ud(7)==6;
               len6 = 'on';
            elseif ud(7)==7;
               len7 = 'on';
            elseif ud(7)==8;
               len8 = 'on';
            elseif ud(7)==9;
               len9 = 'on';
            elseif ud(7)==10;
               len10 = 'on';
            elseif ud(7)==11;
               len11 = 'on';
            elseif ud(7)==12;
               len12 = 'on';
            elseif ud(7)==13;
               len13 = 'on';
            elseif ud(7)==14;
               len14 = 'on';
            elseif ud(7)==15;
               len15 = 'on';
            elseif ud(7)==16;
               len16 = 'on';
            elseif ud(7)==17;
               len17 = 'on';
            elseif ud(7)==18;
               len18 = 'on';
            elseif ud(7)==19;
               len19 = 'on';
            elseif ud(7)==20;
               len20 = 'on';
            elseif ud(7)==21;
               len21 = 'on';
            elseif ud(7)==22;
               len22 = 'on';
            elseif ud(7)==23;
               len23 = 'on';
            elseif ud(7)==24;
               len24 = 'on';
            elseif ud(7)==25;
               len25 = 'on';
            elseif ud(7)==26;
               len26 = 'on';
            elseif ud(7)==27;
               len27 = 'on';
            elseif ud(7)==28;
               len28 = 'on';
            elseif ud(7)==29;
               len29 = 'on';
            elseif ud(7)==30;
               len30 = 'on';
            end;
            arrow_length_menu = uimenu('Parent',arrow_context_menu,'Separator','on','Label','Length');
               uimenu('Parent',arrow_length_menu,'Label','4','Checked',len4,'Callback','change_arrow_length(4); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','5','Checked',len5,'Callback','change_arrow_length(5); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','6','Checked',len6,'Callback','change_arrow_length(6); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','7','Checked',len7,'Callback','change_arrow_length(7); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','8','Checked',len8,'Callback','change_arrow_length(8); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','9','Checked',len9,'Callback','change_arrow_length(9); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','10','Checked',len10,'Callback','change_arrow_length(10); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','11','Checked',len11,'Callback','change_arrow_length(11); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','12','Checked',len12,'Callback','change_arrow_length(12); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','13','Checked',len13,'Callback','change_arrow_length(13); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','14','Checked',len14,'Callback','change_arrow_length(14); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','15','Checked',len15,'Callback','change_arrow_length(15); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','16','Checked',len16,'Callback','change_arrow_length(16); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','17','Checked',len17,'Callback','change_arrow_length(17); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','18','Checked',len18,'Callback','change_arrow_length(18); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','19','Checked',len19,'Callback','change_arrow_length(19); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','20','Checked',len20,'Callback','change_arrow_length(20); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','21','Checked',len21,'Callback','change_arrow_length(21); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','22','Checked',len22,'Callback','change_arrow_length(22); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','23','Checked',len23,'Callback','change_arrow_length(23); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','24','Checked',len24,'Callback','change_arrow_length(24); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','25','Checked',len25,'Callback','change_arrow_length(25); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','26','Checked',len26,'Callback','change_arrow_length(26); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','27','Checked',len27,'Callback','change_arrow_length(27); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','28','Checked',len28,'Callback','change_arrow_length(28); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','29','Checked',len29,'Callback','change_arrow_length(29); uimenu_check_fcn');
               uimenu('Parent',arrow_length_menu,'Label','30','Checked',len30,'Callback','change_arrow_length(30); uimenu_check_fcn');
            base5 = 'off';
            base10 = 'off';
            base15 = 'off';
            base20 = 'off';
            base25 = 'off';
            base30 = 'off';
            base35 = 'off';
            base40 = 'off';
            base45 = 'off';
            base50 = 'off';
            base55 = 'off';
            base60 = 'off';
            base65 = 'off';
            base70 = 'off';
            base75 = 'off';
            base80 = 'off';
            base85 = 'off';
            base90 = 'off';
            if ud(8)==5;
               base5 = 'on';
            elseif ud(8)==10;
               base10 = 'on';
            elseif ud(8)==15;
               base15 = 'on';
            elseif ud(8)==20;
               base20 = 'on';
            elseif ud(8)==25;
               base25 = 'on';
            elseif ud(8)==30;
               base30 = 'on';
            elseif ud(8)==35;
               base35 = 'on';
            elseif ud(8)==40;
               base40 = 'on';
            elseif ud(8)==45;
               base45 = 'on';
            elseif ud(8)==50;
               base50 = 'on';
            elseif ud(8)==55;
               base55 = 'on';
            elseif ud(8)==60;
               base60 = 'on';
            elseif ud(8)==65;
               base65 = 'on';
            elseif ud(8)==70;
               base70 = 'on';
            elseif ud(8)==75;
               base75 = 'on';
            elseif ud(8)==80;
               base80 = 'on';
            elseif ud(8)==85;
               base85 = 'on';
            elseif ud(8)==90;
               base90 = 'on';
            end;
            arrow_base_menu = uimenu('Parent',arrow_context_menu,'Label','Base Angle');
               uimenu('Parent',arrow_base_menu,'Label','5','Checked',base5,'Callback','change_arrow_base(5)');
               uimenu('Parent',arrow_base_menu,'Label','10','Checked',base10,'Callback','change_arrow_base(10); uimenu_check_fcn');
               uimenu('Parent',arrow_base_menu,'Label','15','Checked',base15,'Callback','change_arrow_base(15); uimenu_check_fcn');
               uimenu('Parent',arrow_base_menu,'Label','20','Checked',base20,'Callback','change_arrow_base(20); uimenu_check_fcn');
               uimenu('Parent',arrow_base_menu,'Label','25','Checked',base25,'Callback','change_arrow_base(25); uimenu_check_fcn');
               uimenu('Parent',arrow_base_menu,'Label','30','Checked',base30,'Callback','change_arrow_base(30); uimenu_check_fcn');
               uimenu('Parent',arrow_base_menu,'Label','35','Checked',base35,'Callback','change_arrow_base(35); uimenu_check_fcn');
               uimenu('Parent',arrow_base_menu,'Label','40','Checked',base40,'Callback','change_arrow_base(40); uimenu_check_fcn');
               uimenu('Parent',arrow_base_menu,'Label','45','Checked',base45,'Callback','change_arrow_base(45); uimenu_check_fcn');
               uimenu('Parent',arrow_base_menu,'Label','50','Checked',base50,'Callback','change_arrow_base(50); uimenu_check_fcn');
               uimenu('Parent',arrow_base_menu,'Label','55','Checked',base55,'Callback','change_arrow_base(55); uimenu_check_fcn');
               uimenu('Parent',arrow_base_menu,'Label','60','Checked',base60,'Callback','change_arrow_base(60); uimenu_check_fcn');
               uimenu('Parent',arrow_base_menu,'Label','65','Checked',base65,'Callback','change_arrow_base(65); uimenu_check_fcn');
               uimenu('Parent',arrow_base_menu,'Label','70','Checked',base70,'Callback','change_arrow_base(70); uimenu_check_fcn');
               uimenu('Parent',arrow_base_menu,'Label','75','Checked',base75,'Callback','change_arrow_base(75); uimenu_check_fcn');
               uimenu('Parent',arrow_base_menu,'Label','80','Checked',base80,'Callback','change_arrow_base(80); uimenu_check_fcn');
               uimenu('Parent',arrow_base_menu,'Label','85','Checked',base85,'Callback','change_arrow_base(85); uimenu_check_fcn');
               uimenu('Parent',arrow_base_menu,'Label','90','Checked',base90,'Callback','change_arrow_base(90)');
            tip4 = 'off';
            tip8 = 'off';
            tip12 = 'off';
            tip16 = 'off';
            tip20 = 'off';
            tip24 = 'off';
            tip28 = 'off';
            tip32 = 'off';
            tip36 = 'off';
            tip40 = 'off';
            tip44 = 'off';
            tip48 = 'off';
            tip52 = 'off';
            tip56 = 'off';
            tip60 = 'off';
            if ud(9)==4;
               tip4 = 'on';
            elseif ud(9)==8;
               tip8 = 'on';
            elseif ud(9)==12;
               tip12 = 'on';
            elseif ud(9)==16;
               tip16 = 'on';
            elseif ud(9)==20;
               tip20 = 'on';
            elseif ud(9)==24;
               tip24 = 'on';
            elseif ud(9)==28;
               tip28 = 'on';
            elseif ud(9)==32;
               tip32 = 'on';
            elseif ud(9)==36;
               tip36 = 'on';
            elseif ud(9)==40;
               tip40 = 'on';
            elseif ud(9)==44;
               tip44 = 'on';
            elseif ud(9)==48;
               tip48 = 'on';
            elseif ud(9)==52;
               tip52 = 'on';
            elseif ud(9)==56;
               tip56 = 'on';
            elseif ud(9)==60;
               tip60 = 'on';
            end;
            arrow_tip_menu = uimenu('Parent',arrow_context_menu,'Label','Tip Angle');
               uimenu('Parent',arrow_tip_menu,'Label','4','Checked',tip4,'Callback','change_arrow_tip(4); uimenu_check_fcn');
               uimenu('Parent',arrow_tip_menu,'Label','8','Checked',tip8,'Callback','change_arrow_tip(8); uimenu_check_fcn');
               uimenu('Parent',arrow_tip_menu,'Label','12','Checked',tip12,'Callback','change_arrow_tip(12); uimenu_check_fcn');
               uimenu('Parent',arrow_tip_menu,'Label','16','Checked',tip16,'Callback','change_arrow_tip(16); uimenu_check_fcn');
               uimenu('Parent',arrow_tip_menu,'Label','20','Checked',tip20,'Callback','change_arrow_tip(20); uimenu_check_fcn');
               uimenu('Parent',arrow_tip_menu,'Label','24','Checked',tip24,'Callback','change_arrow_tip(24); uimenu_check_fcn');
               uimenu('Parent',arrow_tip_menu,'Label','28','Checked',tip28,'Callback','change_arrow_tip(28); uimenu_check_fcn');
               uimenu('Parent',arrow_tip_menu,'Label','32','Checked',tip32,'Callback','change_arrow_tip(32); uimenu_check_fcn');
               uimenu('Parent',arrow_tip_menu,'Label','36','Checked',tip36,'Callback','change_arrow_tip(36); uimenu_check_fcn');
               uimenu('Parent',arrow_tip_menu,'Label','40','Checked',tip40,'Callback','change_arrow_tip(40); uimenu_check_fcn');
               uimenu('Parent',arrow_tip_menu,'Label','44','Checked',tip44,'Callback','change_arrow_tip(44); uimenu_check_fcn');
               uimenu('Parent',arrow_tip_menu,'Label','48','Checked',tip48,'Callback','change_arrow_tip(48); uimenu_check_fcn');
               uimenu('Parent',arrow_tip_menu,'Label','52','Checked',tip52,'Callback','change_arrow_tip(52); uimenu_check_fcn');
               uimenu('Parent',arrow_tip_menu,'Label','56','Checked',tip56,'Callback','change_arrow_tip(56); uimenu_check_fcn');
               uimenu('Parent',arrow_tip_menu,'Label','60','Checked',tip60,'Callback','change_arrow_tip(60); uimenu_check_fcn');
            wid0 = 'off';
            wid1 = 'off';
            wid2 = 'off';
            wid3 = 'off';
            wid4 = 'off';
            wid5 = 'off';
            wid6 = 'off';
            wid7 = 'off';
            wid8 = 'off';
            wid9 = 'off';
            wid10 = 'off';
            if ud(10)==0;
               wid0 = 'on';
            elseif ud(10)==1;
               wid1 = 'on';
            elseif ud(10)==2;
               wid2 = 'on';
            elseif ud(10)==3;
               wid3 = 'on';
            elseif ud(10)==4;
               wid4 = 'on';
            elseif ud(10)==5;
               wid5 = 'on';
            elseif ud(10)==6;
               wid6 = 'on';
            elseif ud(10)==7;
               wid7 = 'on';
            elseif ud(10)==8;
               wid8 = 'on';
            elseif ud(10)==9;
               wid9 = 'on';
            elseif ud(10)==10;
               wid10 = 'on';
            end;
            arrow_width_menu = uimenu('Parent',arrow_context_menu,'Label','Width');
               uimenu('Parent',arrow_width_menu,'Label','0','Checked',wid0,'Callback','change_arrow_width(0); uimenu_check_fcn');
               uimenu('Parent',arrow_width_menu,'Label','1','Checked',wid1,'Callback','change_arrow_width(1); uimenu_check_fcn');
               uimenu('Parent',arrow_width_menu,'Label','2','Checked',wid2,'Callback','change_arrow_width(2); uimenu_check_fcn');
               uimenu('Parent',arrow_width_menu,'Label','3','Checked',wid3,'Callback','change_arrow_width(3); uimenu_check_fcn');
               uimenu('Parent',arrow_width_menu,'Label','4','Checked',wid4,'Callback','change_arrow_width(4); uimenu_check_fcn');
               uimenu('Parent',arrow_width_menu,'Label','5','Checked',wid5,'Callback','change_arrow_width(5); uimenu_check_fcn');
               uimenu('Parent',arrow_width_menu,'Label','6','Checked',wid6,'Callback','change_arrow_width(6); uimenu_check_fcn');
               uimenu('Parent',arrow_width_menu,'Label','7','Checked',wid7,'Callback','change_arrow_width(7); uimenu_check_fcn');
               uimenu('Parent',arrow_width_menu,'Label','8','Checked',wid8,'Callback','change_arrow_width(8); uimenu_check_fcn');
               uimenu('Parent',arrow_width_menu,'Label','9','Checked',wid9,'Callback','change_arrow_width(9); uimenu_check_fcn');
               uimenu('Parent',arrow_width_menu,'Label','10','Checked',wid10,'Callback','change_arrow_width(10); uimenu_check_fcn');
            uimenu('Parent',arrow_context_menu,'Separator','on','Label','Shift Tip','Callback','change_arrow_tippos');
            uimenu('Parent',arrow_context_menu,'Separator','on','Label','Cut','Callback','delete(gco); empty_axes');
            set(mypatches(1,j),'UIContextMenu',arrow_context_menu);
         end;
      end;
   end;

   %
   % File menu
   %

   filemenu = uimenu('Parent',h, ...
      'Label','&File', ...
      'Tag','FileMenu');

   %
   % Objects on File menu
   %

   uimenu('parent',filemenu, ...
      'Label','&New Figure', ...
      'Callback','new_figure_fcn', ...
      'Enable','on', ...
      'Accelerator','F', ...
      'Tag','NewMenu');

   uimenu('parent',filemenu, ...
      'Label','&Open Figure...', ...
      'Callback','view_graphics_fcn', ...
      'Enable','on', ...
      'Accelerator','O', ...
      'Tag','OpenMenu');

   uimenu('parent',filemenu, ...
      'Label','&Save...', ...
      'Callback','toolbar_save_fcn', ...
      'Enable','on', ...
      'Accelerator','S', ...
      'Tag','SaveMenu');

   uimenu('Parent',filemenu, ...
      'Label','Save &As...', ...
      'Separator','on', ...
      'Callback','toolbar_saveas_fcn', ...
      'Enable','on', ...
      'Accelerator','V', ...
      'Tag','SaveAs');

   uimenu('Parent',filemenu, ...
      'Label','&Print', ...
      'Separator','on', ...
      'Accelerator','P', ...
      'Callback','toolbar_print_fcn', ...
      'Enable',psprintenable, ...
      'Tag','PrintMenu');

   if strcmp(computer,'PCWIN')==1;
      uimenu('Parent',filemenu, ...
         'Label','Prin&t Setup...', ...
         'Callback','uimenufcn(gcbf,''FilePrintSetup'')', ...
         'Enable',psprintenable, ...
         'Tag','PrintSetupMenu');
   end;

   uimenu('Parent',filemenu, ...
      'Label','Pa&ge Setup...', ...
      'Accelerator','G', ...
      'Callback','page_setup', ...
      'Enable','on', ...
      'Tag','PageSetupMenu');

   uimenu('Parent',filemenu, ...
      'Label','Pr&int Preview...', ...
      'Accelerator','I', ...
      'Callback','printpreview_fcn(gcf)', ...
      'Enable',psprintenable, ...
      'Tag','PrintPreviewMenu');

   uimenu('Parent',filemenu, ...
      'Label','&Close', ...
      'Separator','on', ...
      'Accelerator','Q', ...
      'Callback','close(gcf); drawnow', ...
      'Enable','on', ...
      'Tag','Close');

   %
   % Edit menu
   %

   editmenu = uimenu('Parent',h, ...
      'Label','&Edit', ...
      'Tag','EditMenu');

   %
   % Objects on edit menu
   %

   uimenu('Parent',editmenu, ...
      'Label','Ax&es Properties...', ...
      'Callback','toolbar_edit_fcn', ...
      'Accelerator','E', ...
      'Enable','on', ...
      'Tag','EditGraph');

   if curr_ini.show_undo==1;
      toolbar.undomenu = uimenu('Parent',editmenu, ...
         'Label','&Undo', ...
         'Callback','undofigure', ...
         'Accelerator','U', ...
         'Enable','on', ...
         'Tag','UndoMenu');
   end;

   toolbar.name = uimenu('Parent',editmenu, ...
      'Label','&New Figure Name...', ...
      'Callback','toolbar_name_fcn', ...
      'Enable','on', ...
      'Tag','NameMenu');


   toolbar.addmenu = uimenu('Parent',editmenu, ...
      'Separator','on', ...
      'Label','&Add', ...
      'Enable','on', ...
      'Tag','Add');

      toolbar.axesmenu = uimenu('Parent',toolbar.addmenu,'Label','A&xes','Accelerator','X','Callback','toolbar_addaxes_fcn');
      toolbar.freehandmenu = uimenu('Parent',toolbar.addmenu,'Label','&Draw Freehand','Accelerator','D','Callback','menu_freehand_fcn');
      if isempty(mysurf)==1;
         toolbar.rectanglemenu = uimenu('Parent',toolbar.addmenu,'Label','&Rectangle','Accelerator','R','Callback','menu_rectangle_fcn');
      end;
      toolbar.textmenu = uimenu('Parent',toolbar.addmenu,'Label','&Text','Accelerator','T','Callback','menu_addtext_fcn');
      toolbar.arrowmenu = uimenu('Parent',toolbar.addmenu,'Label','&Arrow','Accelerator','A','Callback','menu_addarrow_fcn');
      toolbar.linemenu = uimenu('Parent',toolbar.addmenu,'Label','&Line','Accelerator','L','Callback','menu_addline_fcn');

   toolbar.legend = uimenu('Parent',editmenu, ...
      'Separator','on', ...
      'Label',leg_str, ...
      'Accelerator','N', ...
      'Callback','toolbar_legend_fcn', ...
      'Enable',legenable, ...
      'Tag','LegendShow');

   toolbar.plotbox = uimenu('Parent',editmenu, ...
      'Label',boxstr, ...
      'Callback','toolbar_box_fcn', ...
      'Accelerator','B', ...
      'Enable','on', ...
      'Tag','PlotBox');

   %
   % Tools menu
   %

   toolsmenu = uimenu('Parent',h, ...
      'Label','&Tools', ...
      'Tag','ToolsMenu');

   %
   % Objects to Tools menu
   %

   toolbar.lock = uimenu('Parent',toolsmenu, ...
      'Label','Unloc&k Axes', ...
      'Accelerator','K', ...
      'Callback','toolbar_lock_fcn', ...
      'Enable','on', ...
      'Tag','LockType');

   toolbar.renderer = uimenu('Parent',toolsmenu, ...
      'Label','&Renderer', ...
      'Enable','on', ...
      'Tag','Renderer');

      painters_check = 'off';
      zbuffer_check = 'off';
      if strcmp(lower(get(h,'Renderer')),'painters')==1;
         painters_check = 'on';
      elseif strcmp(lower(get(h,'Renderer')),'zbuffer')==1;
         zbuffer_check = 'on';
      end;
      if (strcmp(painters_check,'on')==1)&(isempty(mysurf)==0);
         painters_check = 'off';
         zbuffer_check = 'on';
         set(h,'Renderer','zbuffer');
      elseif (strcmp(painters_check,'off')==1)&(strcmp(zbuffer_check,'off')==1);
         painters_check = 'on';
         set(h,'Renderer','painters');
      end;

   toolbar.refresh = uimenu('Parent',toolsmenu, ...
      'Label','Refresh &Figure', ...
      'Callback','refresh(gcf); drawnow;', ...
      'Enable','on', ...
      'Tag','RefreshMenu');

   toolbar.alignment = uimenu('Parent',toolsmenu, ...
      'Label','&Align Axes', ...
      'Enable','on', ...
      'Tag','AlignmentMenu');

   toolbar.align_row1 = uimenu('Parent',toolbar.alignment, ...
      'Label','&1 Row', ...
      'Enable','on', ...
      'Tag','Align1Row', ...
      'Callback','axes_alignment(1,0)');

   toolbar.align_row2 = uimenu('Parent',toolbar.alignment, ...
      'Label','&2 Rows', ...
      'Enable','on', ...
      'Tag','Align2Row', ...
      'Callback','axes_alignment(2,0)');

   toolbar.align_row3 = uimenu('Parent',toolbar.alignment, ...
      'Label','&3 Rows', ...
      'Enable','on', ...
      'Tag','Align3Row', ...
      'Callback','axes_alignment(3,0)');

   toolbar.align_row4 = uimenu('Parent',toolbar.alignment, ...
      'Label','&4 Rows', ...
      'Enable','on', ...
      'Tag','Align4Row', ...
      'Callback','axes_alignment(4,0)');

   toolbar.align_col1 = uimenu('Parent',toolbar.alignment, ...
      'Label','&One Column', ...
      'Enable','on', ...
      'Separator','on', ...
      'Tag','Align1Column', ...
      'Callback','axes_alignment(0,1)');

   toolbar.align_col2 = uimenu('Parent',toolbar.alignment, ...
      'Label','&Two Columns', ...
      'Enable','on', ...
      'Tag','Align2Column', ...
      'Callback','axes_alignment(0,2)');

   toolbar.align_col3 = uimenu('Parent',toolbar.alignment, ...
      'Label','T&hree Columns', ...
      'Enable','on', ...
      'Tag','Align3Column', ...
      'Callback','axes_alignment(0,3)');

   toolbar.align_col4 = uimenu('Parent',toolbar.alignment, ...
      'Label','&Four Columns', ...
      'Enable','on', ...
      'Tag','Align4Column', ...
      'Callback','axes_alignment(0,4)');


   if (curr_ini.use_toolbar_bgcolor==1)&(strcmp(get(h,'Renderer'),'zbuffer')==1);
      figcolor = (1/255)*(round(255*get(0,'defaultuicontrolbackgroundcolor'))-[8 4 8]);
      figcolor(1) = max(0,figcolor(1));
      figcolor(2) = max(0,figcolor(2));
      figcolor(3) = max(0,figcolor(3));
   else;
      figcolor = get(0,'defaultuicontrolbackgroundcolor');
   end;
   set(h,'Color',figcolor);

      uimenu('Parent',toolbar.renderer, ...
         'Label','&Painters', ...
         'Checked',painters_check, ...
         'Enable','on', ...
         'Callback','toolbar_renderer_fcn', ...
         'Tag','painters');

      uimenu('Parent',toolbar.renderer, ...
         'Label','&Zbuffer', ...
         'Checked',zbuffer_check, ...
         'Enable','on', ...
         'Callback','toolbar_renderer_fcn', ...
         'Tag','zbuffer');

      toolbar.movies = uimenu('Parent',toolsmenu, ...
         'Label','Mo&vies', ...
         'Separator','on', ...
         'Enable','on', ...
         'Tag','MenuMovies3D');

      toolbar.menumovie = uimenu('Parent',toolbar.movies, ...
         'Label','&Show Movie', ...
         'Callback','movie_3d_fcn', ...
         'Enable','on', ...
         'Tag','MenuMovie3D');

   if isempty(mysurf)==0;

      toolbar.menurecordmovie_h = uimenu('Parent',toolbar.movies, ...
         'Label','&Record H-Movie', ...
         'Callback','record_3dmovie_fcn', ...
         'Separator','on', ...
         'Enable','on', ...
         'Tag','MenuRecord3DMovieHoriz');

      toolbar.menurecordmovie_v = uimenu('Parent',toolbar.movies, ...
         'Label','R&ecord V-Movie', ...
         'Callback','record_3dmovie_fcn(0)', ...
         'Enable','on', ...
         'Tag','MenuRecord3DMovieVert');

      uimenu('Parent',toolsmenu, ...
         'Label','Return &Original View', ...
         'Callback','toolbar_rotate_default_fcn', ...
         'Accelerator','R', ...
         'Separator','on', ...
         'Enable','on', ...
         'Tag','RotateDefaultView');

      if isempty(show_hide_surf)==0;
         toolbar.showhidesurface = uimenu('Parent',toolsmenu, ...
            'Label',show_hide_surf, ...
            'Callback','toolbar_show_hide_surface_fcn', ...
            'Enable','on', ...
            'UserData',show_hide_ud, ...
            'Tag','ShowHideSurface');
      end;

      if isempty(this_colorbar)==0;
         if strcmp(get(this_colorbar(1,1),'Visible'),'on')==1;
            toolbar.colorbar = uimenu('Parent',toolsmenu, ...
               'Label','&Hide Colorbar', ...
               'Callback','toolbar_colorbar_fcn', ...
               'Enable','on', ...
               'Tag','ColorBar');

            toolbar.deletecolorbar = uimenu('Parent',toolsmenu, ...
               'Label','&Delete Colorbar', ...
               'Callback','delete_colorbar_fcn', ...
               'Enable','on', ...
               'Tag','DeleteColorBar');
         else;
            toolbar.deletecolorbar = uimenu('Parent',toolsmenu, ...
               'Label','&Add Colorbar', ...
               'Callback','add_colorbar_fcn', ...
               'Enable','on', ...
               'Tag','DeleteColorBar');
         end;
      else;
         toolbar.deletecolorbar = uimenu('Parent',toolsmenu, ...
            'Label','&Add Colorbar', ...
            'Callback','toolbar_addcolorbar_fcn', ...
            'Enable','on', ...
            'Tag','DeleteColorBar');
      end;


   end;

   toolbar.hidden = uimenu('Parent',toolsmenu, ...
      'Label','&Show Hidden Lines', ...
      'Separator','on', ...
      'Callback','menu_show_hidden_fcn', ...
      'Enable','off', ...
      'Tag','MenuHidden');

   toolbar.center = uimenu('Parent',toolsmenu, ...
      'Label','&Center Window', ...
      'Accelerator','W', ...
      'Callback','center_figure_fcn', ...
      'Enable','on', ...
      'Tag','MenuCenter');

   toolbar.menuzoomin = uimenu('Parent',toolsmenu, ...
      'Label','&Zoom In', ...
      'Separator','on', ...
      'Accelerator','Z', ...
      'Callback','menu_zoomin_fcn', ...
      'Enable','on', ...
      'Tag','MenuZoomIn');

   toolbar.menuzoomout = uimenu('Parent',toolsmenu, ...
      'Label','Zoo&m Out', ...
      'Callback','menu_zoomout_fcn', ...
      'Accelerator','M', ...
      'Enable','on', ...
      'Tag','MenuZoomOut');

   if isempty(mysurf)==0;

      toolbar.menurotate3d = uimenu('Parent',toolsmenu, ...
         'Label','Rotate &3D', ...
         'Callback','menu_rotate3d_fcn', ...
         'Accelerator','3', ...
         'Enable','on', ...
         'Tag','MenuRotate3D');

   end;

   if strcmp(curr_ini.helpexe,'')==1;
      helpenable = 'off';
   else;
      helpenable = 'on';
   end;

   helpmenu = uimenu('Parent',h, ...
      'Label','&Help', ...
      'Tag','HelpMenu');

   toolbar.helpmenu = uimenu('Parent',helpmenu, ...
      'Label','&Help Topics', ...
      'Accelerator','H', ...
      'Callback','help_fcn(''editing_graphics'')', ...
      'Enable',helpenable, ...
      'Tag','MenuHelp');

   toolbar.about = uimenu('Parent',helpmenu, ...
      'Separator','on', ...
      'Label','&About', ...
      'Callback','figeditor_about_fcn', ...
      'Enable','on', ...
      'Tag','MenuAbout');

   %
   % Toolbar with axes background
   %


   toolbar.toolbar = uitoolbar('Parent',h, ...
                     'HandleVisibility','off', ...
                     'Interruptible','on', ...
                     'Clipping','on');

%   toolbar.background = axes('Units','pixels', ...
%         'Color',get(0,'defaultuicontrolbackgroundcolor'), ...
%         'XColor',get(0,'defaultuicontrolbackgroundcolor'), ...
%         'YColor',get(0,'defaultuicontrolbackgroundcolor'), ...
%         'ZColor',get(0,'defaultuicontrolbackgroundcolor'), ...
%         'Box','on', ...
%         'TickLength',[0 0], ...
%         'XTickLabel',[], ...
%         'YTickLabel',[], ...
%         'XTick',[0 1], ...
%         'YTick',[0 1], ...
%         'Position',[1 height-38 width 40], ...
%         'Visible','on', ...
%         'Tag','Background');

   %
   % x-axes lines
   %

   toolbar.box1 = xline([1 height-1 width],[0.5 1]);

%   toolbar.box2 = xline([1 height-36 width],[0.5 1]);

   %
   % New figure button
   %

   toolbar.new = uipushtool('Parent',toolbar.toolbar, ...
                         'TooltipString','New Figure', ...
                         'CData',my_new, ...
                         'ClickedCallback','new_figure_fcn', ...
                         'Separator','off', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'Enable','on', ...
                         'Tag','NewButton');

%   toolbar.new = uicontrol('Units','pixels', ...
%      'Parent',h, ...
%      'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
%      'Position',[10 height-30 22 22], ...
%      'TooltipString','New Figure', ...
%      'CallBack','new_figure_fcn', ...
%      'Enable','on', ...
%      'CData',my_new, ...
%      'HorizontalAlignment','center', ...
%      'Tag','NewButton');

   %
   % Open figure button
   %

   toolbar.open = uipushtool('Parent',toolbar.toolbar, ...
                         'TooltipString','Open Figure', ...
                         'CData',my_viewgraphics, ...
                         'ClickedCallback','view_graphics_fcn', ...
                         'Separator','off', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'Enable','on', ...
                         'Tag','OpenButton');

%   toolbar.open = uicontrol('Units','pixels', ...
%      'Parent',h, ...
%      'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
%      'Position',[32 height-30 22 22], ...
%      'TooltipString','Open Figure', ...
%      'CallBack','view_graphics_fcn', ...
%      'Enable','on', ...
%      'CData',my_viewgraphics, ...
%      'HorizontalAlignment','center', ...
%      'Tag','OpenButton');

   if curr_ini.crop_image==1;
      set(toolbar.open,'UserData',1);
   end;

   toolbar.save = uipushtool('Parent',toolbar.toolbar, ...
                         'TooltipString','Save', ...
                         'CData',mysave, ...
                         'ClickedCallback','toolbar_save_fcn', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'Enable','on', ...
                         'Tag','SaveButton');

%   toolbar.ybox = yline([60 height-30 22],[0.5 1]);

   %
   % save as button
   %

   toolbar.saveas = uipushtool('Parent',toolbar.toolbar, ...
                         'TooltipString','Save As', ...
                         'CData',mysaveas, ...
                         'ClickedCallback','toolbar_saveas_fcn', ...
                         'Separator','on', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'UserData',0, ...
                         'Enable','on', ...
                         'Tag','SaveAsButton');

%   toolbar.saveas = uicontrol('Units','pixels', ...
%      'Parent',h, ...
%      'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
%      'Position',[68 height-30 22 22], ...
%      'TooltipString','Save As', ...
%      'CallBack','toolbar_saveas_fcn', ...
%      'Enable','on', ...
%      'UserData',0, ...
%      'CData',mysaveas, ...
%      'HorizontalAlignment','center', ...
%      'Tag','SaveAsButton');

   %
   % print button
   %

   toolbar.print = uipushtool('Parent',toolbar.toolbar, ...
                         'TooltipString','Print', ...
                         'CData',myprintenable, ...
                         'ClickedCallback','toolbar_print_fcn', ...
                         'Separator','off', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'UserData',myaxes, ...
                         'Enable',psprintenable, ...
                         'Tag','PrintButton');

%   toolbar.print = uicontrol('Units','pixels', ...
%      'Parent',h, ...
%      'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
%      'Position',[90 height-30 22 22], ...
%      'TooltipString','Print', ...
%      'CallBack','toolbar_print_fcn', ...
%      'Enable',psprintenable, ...
%      'UserData',myaxes, ...
%      'CData',printbutton, ...
%      'HorizontalAlignment','center', ...
%      'Tag','PrintButton');

%   toolbar.ybox1 = yline([118 height-30 22],[0.5 1]);


   if curr_ini.show_undo==1;
      toolbar.undo = uipushtool('Parent',toolbar.toolbar, ...
                         'TooltipString','Undo', ...
                         'CData',my_undo, ...
                         'ClickedCallback','undofigure', ...
                         'Separator','on', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'Enable','on', ...
                         'Tag','UndoButton');
   end;

   toolbar.movie = uipushtool('Parent',toolbar.toolbar, ...
                         'TooltipString','Show Movie', ...
                         'CData',my_moviestar, ...
                         'Separator','on', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'ClickedCallback','movie_3d_fcn', ...
                         'Enable','on', ...
                         'Tag','MovieButton');


%   if isempty(mysurf)==0;
%      toolbar.recordmovie_h = uipushtool('Parent',toolbar.toolbar, ...
%                         'TooltipString','Record H-Movie', ...
%                         'CData',my_rec_movie_horizontal, ...
%                         'Separator','on', ...
%                         'Interruptible','on', ...
%                         'Clipping','on', ...
%                         'ClickedCallback','record_3dmovie_fcn(1)', ...
%                         'Enable','on', ...
%                         'Tag','RecordMovieHButton');
%      toolbar.recordmovie_v = uipushtool('Parent',toolbar.toolbar, ...
%                         'TooltipString','Record V-Movie', ...
%                         'CData',my_rec_movie_vertical, ...
%                         'Separator','off', ...
%                         'Interruptible','on', ...
%                         'Clipping','on', ...
%                         'ClickedCallback','record_3dmovie_fcn(0)', ...
%                         'Enable','on', ...
%                         'Tag','RecordMovieVButton');
%   end;

   %
   % Edit button
   %

   toolbar.edit = uipushtool('Parent',toolbar.toolbar, ...
                         'TooltipString','Axes Properties', ...
                         'CData',myeditgraph, ...
                         'ClickedCallback','toolbar_edit_fcn', ...
                         'Separator','on', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'Enable','on', ...
                         'Tag','EditButton');

   toolbar.axes = uitoggletool('Parent',toolbar.toolbar, ...
                         'TooltipString','Add Axes', ...
                         'CData',my_axes, ...
                         'ClickedCallback','toolbar_addaxes_fcn', ...
                         'Separator','on', ...
                         'State','off', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'Enable','on', ...
                         'Tag','AxesButton');

   toolbar.freehand = uitoggletool('Parent',toolbar.toolbar, ...
                         'TooltipString','Draw Freehand', ...
                         'CData',myfreehand, ...
                         'ClickedCallback','toolbar_freehand_fcn', ...
                         'Separator','off', ...
                         'State','off', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'Enable','on', ...
                         'Tag','FreehandButton');

   if isempty(mysurf)==1;

      toolbar.rectangle = uitoggletool('Parent',toolbar.toolbar, ...
                            'TooltipString','Add Rectangle', ...
                            'CData',myrectangle, ...
                            'ClickedCallback','toolbar_rectangle_fcn', ...
                            'State','off', ...
                            'Interruptible','on', ...
                            'Clipping','on', ...
                            'Enable','on', ...
                            'Tag','RectangleButton');

   end;

%   toolbar.edit = uicontrol('Units','pixels', ...
%      'Parent',h, ...
%      'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
%      'Position',[126 height-30 22 22], ...
%      'TooltipString','Edit Graph', ...
%      'CallBack','toolbar_edit_fcn', ...
%      'Enable','on', ...
%      'CData',myeditgraph, ...
%      'HorizontalAlignment','center', ...
%      'Tag','EditButton');

   toolbar.addtext = uitoggletool('Parent',toolbar.toolbar, ...
                         'TooltipString','Add Text', ...
                         'CData',my_text, ...
                         'ClickedCallback','toolbar_addtext_fcn', ...
                         'Separator','off', ...
                         'State','off', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'UserData','', ...
                         'Enable','on', ...
                         'Tag','AddTextButton');

%   toolbar.addtext = uicontrol('Units','pixels', ...
%         'Parent',h, ...
%         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
%         'Position',[148 height-30 22 22], ...
%         'TooltipString','Add Text', ...
%         'Style','togglebutton', ...
%         'Value',0, ...
%         'Enable','on', ...
%         'Callback','toolbar_addtext_fcn', ...
%         'UserData','', ...
%         'CData',my_text, ...
%         'HorizontalAlignment','center', ...
%         'Tag','AddTextButton');

   toolbar.addarrow = uitoggletool('Parent',toolbar.toolbar, ...
                         'TooltipString','Add Arrow', ...
                         'CData',my_arrow, ...
                         'ClickedCallback','toolbar_addarrow_fcn', ...
                         'Separator','off', ...
                         'State','off', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'UserData',[], ...
                         'Enable','on', ...
                         'Tag','AddArrowButton');

%   toolbar.addarrow = uicontrol('Units','pixels', ...
%         'Parent',h, ...
%         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
%         'Position',[170 height-30 22 22], ...
%         'TooltipString','Add Arrow', ...
%         'Style','togglebutton', ...
%         'Value',0, ...
%         'Enable','on', ...
%         'Callback','toolbar_addarrow_fcn', ...
%         'UserData',[], ...
%         'CData',my_arrow, ...
%         'HorizontalAlignment','center', ...
%         'Tag','AddArrowButton');

   toolbar.addline = uitoggletool('Parent',toolbar.toolbar, ...
                         'TooltipString','Add Line', ...
                         'CData',my_line, ...
                         'ClickedCallback','toolbar_addline_fcn', ...
                         'Separator','off', ...
                         'State','off', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'UserData',[], ...
                         'Enable','on', ...
                         'Tag','AddLineButton');

%   toolbar.addline = uicontrol('Units','pixels', ...
%         'Parent',h, ...
%         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
%         'Position',[192 height-30 22 22], ...
%         'TooltipString','Add Line', ...
%         'Style','togglebutton', ...
%         'Value',0, ...
%         'Enable','on', ...
%         'Callback','toolbar_addline_fcn', ...
%         'UserData',[], ...
%         'CData',my_line, ...
%         'HorizontalAlignment','center', ...
%         'Tag','AddLineButton');


   addspace = 0;
   if isempty(mysurf)==0;

      addspace = 36;

%      toolbar.ybox2 = yline([220 height-30 22],[0.5 1]);

      toolbar.rotate_default = uipushtool('Parent',toolbar.toolbar, ...
                         'TooltipString','Return Original View', ...
                         'CData',myrotate, ...
                         'ClickedCallback','toolbar_rotate_default_fcn', ...
                         'Separator','on', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'Enable','on', ...
                         'Tag','RotateDefaultButton');

%      toolbar.rotate_default = uicontrol('Units','pixels', ...
%         'Parent',h, ...
%         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
%         'Position',[228 height-30 22 22], ...
%         'TooltipString','Return Original View', ...
%         'CallBack','toolbar_rotate_default_fcn', ...
%         'Enable','on', ...
%         'CData',myrotate, ...
%         'HorizontalAlignment','center', ...
%         'Tag','RotateDefaultButton');

      this_azel = [];
      for i=1:size(myaxes,2);
         this_azel = [this_azel;get(myaxes(1,i),'View')];
      end;

      set(toolbar.rotate_default,'UserData',this_azel);

   end;

%   toolbar.ybox4 = yline([220+addspace height-30 22],[0.5 1]);

   toolbar.zoomin = uitoggletool('Parent',toolbar.toolbar, ...
                         'TooltipString','Zoom In', ...
                         'CData',myzoominup, ...
                         'ClickedCallback','toolbar_zoomin_fcn', ...
                         'Separator','on', ...
                         'State','off', ...
                         'Interruptible','on', ...
                         'UserData','', ...
                         'Clipping','on', ...
                         'Enable','on', ...
                         'Tag','ZoomInButton');

%   toolbar.zoomin = uicontrol('Units','pixels', ...
%         'Parent',h, ...
%         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
%         'Position',[228+addspace height-30 22 22], ...
%         'TooltipString','Zoom In', ...
%         'Style','togglebutton', ...
%         'Value',0, ...
%         'Enable','on', ...
%         'UserData','', ...
%         'Callback','toolbar_zoomin_fcn', ...
%         'CData',myzoominup, ...
%         'HorizontalAlignment','center', ...
%         'Tag','ZoomInButton');

   toolbar.zoomout = uitoggletool('Parent',toolbar.toolbar, ...
                         'TooltipString','Zoom Out', ...
                         'CData',myzoomoutup, ...
                         'ClickedCallback','toolbar_zoomout_fcn', ...
                         'Separator','off', ...
                         'State','off', ...
                         'Interruptible','on', ...
                         'UserData','', ...
                         'Clipping','on', ...
                         'Enable','on', ...
                         'Tag','ZoomOutButton');

%   toolbar.zoomout = uicontrol('Units','pixels', ...
%         'Parent',h, ...
%         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
%         'Position',[250+addspace height-30 22 22], ...
%         'TooltipString','Zoom Out', ...
%         'Style','togglebutton', ...
%         'Value',0, ...
%         'Enable','on', ...
%         'UserData','', ...
%         'Callback','toolbar_zoomout_fcn', ...
%         'CData',myzoomoutup, ...
%         'HorizontalAlignment','center', ...
%         'Tag','ZoomOutButton');


   if isempty(mysurf)==0;

      toolbar.rotate3d = uitoggletool('Parent',toolbar.toolbar, ...
                            'TooltipString','Rotate 3D', ...
                            'CData',myrotate3d_up, ...
                            'ClickedCallback','toolbar_rotate3d_fcn', ...
                            'Separator','off', ...
                            'State','off', ...
                            'Interruptible','on', ...
                            'UserData','', ...
                            'Clipping','on', ...
                            'Enable','on', ...
                            'Tag','Rotate3dButton');

%      toolbar.rotate3d = uicontrol('Units','pixels', ...
%         'Parent',h, ...
%         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
%         'Position',[272+addspace height-30 22 22], ...
%         'TooltipString','Rotate 3D', ...
%         'Style','togglebutton', ...
%         'Value',0, ...
%         'Enable','on', ...
%         'UserData','', ...
%         'Callback','toolbar_rotate3d_fcn', ...
%         'CData',myrotate3d_up, ...
%         'HorizontalAlignment','center', ...
%         'Tag','Rotate3dButton');
   end;

   toolbar.help = uipushtool('Parent',toolbar.toolbar, ...
                         'TooltipString','Help Topics', ...
                         'CData',my_help, ...
                         'ClickedCallback','help_fcn(''editing_graphics'')', ...
                         'Separator','on', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'Enable',helpenable, ...
                         'Tag','HelpButton');

   toolbar.close = uipushtool('Parent',toolbar.toolbar, ...
                         'TooltipString','Close', ...
                         'CData',myclose, ...
                         'ClickedCallback','close(gcf); drawnow', ...
                         'Separator','on', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'Enable','on', ...
                         'Tag','CloseButton');

   %
   % dealing with legends and moving axes to match
   % with new toolbar
   %

   if isempty(this_colorbar)==0;
      for j=1:size(this_colorbar,2);
         old_axes(j).handle = get(this_colorbar(1,j),'UserData');
         set(this_colorbar(1,j),'UserData',[]);
      end;
      if strcmp(get(this_colorbar(1,1),'Visible'),'on')==1;
         myaxes = [myaxes this_colorbar];
      end;
   end;

   old_units = get(myaxes(1,1),'Units');
   set(myaxes(1,1),'Units','pixels');
   ax_pos = get(myaxes(1,1),'Position');
   set(myaxes(1,1),'Units',old_units);
   ref_point = ax_pos(1:2);
   num_rows = 1;

   for i=2:size(myaxes,2);
      old_units = get(myaxes(1,i),'Units');
      set(myaxes(1,i),'Units','pixels');
      ax_pos = get(myaxes(1,i),'Position');
      set(myaxes(1,i),'Units',old_units);
      new_point = ax_pos(1:2);
      if (new_point(1)==ref_point(1))&(new_point(2)<ref_point(2));
         num_rows = num_rows+1;
         ref_point = new_point;
      end;
   end;
   num_cols = ceil(size(myaxes,2)/num_rows);

   %
   % now we now the number of rows and columns of axes that exist
   % in the current figure. it remains to fix the axes such
   % they are in combination 40 pixels smaller in height
   %

   adj_height = 40/num_rows;
   thislegpos = [];
   count = 0;
   for i=1:num_rows;
      for j=1:num_cols;
         count = count+1;
         if count<=size(myaxes,2);
            %
            % fix all the in-between rows of axes in the graph
            %
            old_units = get(myaxes(1,count),'Units');
            set(myaxes(1,count),'Units','pixels');
            axpos = get(myaxes(1,count),'Position')-[0 (num_rows-i)*adj_height 0 adj_height];
%            set(myaxes(1,count),'Position',axpos);
            set(myaxes(1,count),'Units','normalized');
            if isempty(get(myaxes(1,count),'UserData'))==0;
               myleg = get(myaxes(1,count),'UserData');
               set(myleg,'Units','pixels');
               legpos = get(myleg,'Position');
               if legpos(2)+legpos(4)>axpos(2)+axpos(4);
                  legpos = legpos-[0 (num_rows-i+1)*adj_height 0 0];
%                  set(myleg,'Position',legpos);
               end;
               thislegpos = [thislegpos;legpos];
               set(toolbar.edit,'UserData',thislegpos);
               set(myleg,'Units','normalized');
               leg_ud = get(myleg,'UserData');
%               leg_ud.AxesPosition = get(myaxes(1,count),'Position');
%               leg_ud.PlotPosition = get(myaxes(1,count),'Position');
%               leg_ud.LegendPosition = get(myleg,'Position');
               legcontext = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
               uimenu('Parent',legcontext,'Label','Font','Callback','change_legend_font');
               uimenu('Parent',legcontext,'Label','Text Color','Separator','on','Callback','change_legend_text_color');
               uimenu('Parent',legcontext,'Label','Background Color','Callback','change_axes_color');
               uimenu('Parent',legcontext,'Label','Border Color','Callback','change_legend_color');
               uimenu('Parent',legcontext,'Label','Reorder Legend','Separator','on','Callback','reorder_legend_fcn');
               uimenu('Parent',legcontext,'Label','Hide Legend','Separator','on','Callback','toolbar_legend_fcn');
               uimenu('Parent',legcontext,'Label','Lock Legend','Separator','on','Callback','legend_lock_fcn');
               leg_ud.UIContextMenu = legcontext;
               set(myleg,'UIContextMenu',legcontext,'UserData',leg_ud);
               set(get(myleg,'Children'),'UIContextMenu',legcontext);
            end;
            set(myaxes(1,count),'Units',old_units);
         end;
      end;
   end;

   if isempty(this_colorbar)==0;
      for j=1:size(this_colorbar,2);
         set(this_colorbar(1,j),'UserData',old_axes(j).handle);
      end;
   end;

   set(h,'UserData',toolbar,...
      'HandleVisibility','callback',...
      'CloseRequestFcn','killpid; drawnow; drawnow');

   if (iswinnt==1)&(iscompiled==1)&(curr_ini.loadicon==1)&(strcmp(strtrim(curr_ini.pstoolsdir),'')==0);
      %
      % check to make sure that a pid hasn't already been set for this window
      %
      pid = get(toolbar.about,'UserData');
      makepid = 0;
      if isempty(pid)==0;
         makepid = 1-ispid('seticon',pid);
      else;
         makepid = 1;
      end;
      if (makepid==1)&(appexist([curr_ini.pstoolsdir 'pslist.exe'])==1);
         prog = ['bin\runwindow.exe ' fix_path([pwd '\bin\seticon.exe']) ' ' get(h,'Name') ' ' fix_filepath([pwd '\icons\figeditor.ico'])];
         dos(prog);
         %
         % now we need to determine the pid
         %
         pid = getpid('seticon');
         set(toolbar.about,'UserData',pid);
      else;
         set(toolbar.about,'UserData',[]);
      end;
   end;
   %
   % save temporary file
   %
   save_chk = 0;
   num = 0;
   if curr_ini.show_undo==1;
      while save_chk==0;
         file = [curr_ini.tempdir 'tempfile-' num2str(num) '.fig'];
         if fileexist(file)==0;
            set(toolbar.alignment,'UserData',file);
            saveas(h,file);
            save_chk = 1;
         end;
         num = num+1;
      end;
   end;

end;

%
% end of toolbar_fcn.m
%
