function toolbar_legend_fcn

h = get(0,'CurrentFigure');
toolbar = get(h,'UserData');
myaxes = get(toolbar.print,'UserData');

mylegs = [];
mylegother = [];
for i=1:size(myaxes,2);
   new_leg = get(myaxes(1,i),'UserData');
   if isempty(new_leg)==0;
      if ishandle(new_leg)==0;
         new_leg = find_legend(myaxes(1,i));
         set(myaxes(1,i),'UserData',new_leg);
      end;
      mylegs = [mylegs new_leg];
      myleglinesi = findobj(new_leg,'Type','line')';
      mylegpatchi = findobj(new_leg,'Type','patch')';
      mylegtexti = findobj(new_leg,'Type','text')';
      mylegother = [mylegother myleglinesi mylegpatchi mylegtexti];
   end;
end;

legstr = get(toolbar.legend,'Label');
if strcmp(legstr,'Hide &Legend')==1;
   set(toolbar.legend,'Label','Show &Legend');
   for i=1:size(mylegs,2);
      set(mylegs(1,i),'Visible','off');
   end;
   for i=1:size(mylegother,2);
      set(mylegother(1,i),'Visible','off');
   end;
else;
   set(toolbar.legend,'Label','Hide &Legend');
   for i=1:size(mylegs,2);
      set(mylegs(1,i),'Visible','on');
   end;
   for i=1:size(mylegother,2);
      set(mylegother(1,i),'Visible','on');
   end;
end;

%
% end of toolbar_legend_fcn
%

