function toolbar_lock_fcn

%#function checkobj_fcn

h = get(0,'CurrentFigure');
toolbar = get(h,'UserData');
this_label = get(toolbar.lock,'Label');
myaxes = get(toolbar.print,'UserData');

for i=1:size(myaxes,2);
   oldkids(i).handles = get(myaxes(1,i),'Children');
end;

old_myaxes = myaxes;
this_colorbar = findobj(gcf,'Type','axes','Tag','colorbar')';
if isempty(this_colorbar)==0;
   if strcmp(get(this_colorbar,'Visible'),'on')==1;
      myaxes = [myaxes this_colorbar];
   end;
end;

if strcmp(this_label,'Unloc&k Axes')==1;
   tlock.wbdfcn = get(h,'WindowButtonDownFcn');
   tlock.wbmfcn = get(h,'WindowButtonMotionFcn');
   tlock.wbufcn = get(h,'WindowButtonUpFcn');
   tlock.interruptible = get(h,'Interruptible');
   tlock.keypressfcn = get(h,'KeyPressFcn');
   tlock.buttondownfcn = get(h,'ButtonDownFcn');
   tlock.busyaction = get(h,'BusyAction');
   tlock.pointer = get(h,'Pointer');
   set(toolbar.lock,'UserData',tlock);
   set(h,'Pointer','arrow','DoubleBuffer','on');
   set(h,'WindowButtonDownFcn','checkobj_fcn','WindowButtonMotionFcn','','WindowButtonUpFcn','');
   set(toolbar.lock,'Label','Loc&k Axes');
   act = 'on';
   labeltxt = 'Lock Axes';
else;
   act = 'off';
   tlock = get(toolbar.lock,'UserData');
   if (strcmp(get(toolbar.addtext,'State'),'on')==1)|(strcmp(get(toolbar.freehand,'State'),'on')==1)|(strcmp(get(toolbar.addarrow,'State'),'on')==1)|(strcmp(get(toolbar.addline,'State'),'on')==1)|(strcmp(get(toolbar.zoomin,'State'),'on')==1)|(strcmp(get(toolbar.zoomout,'State'),'on')==1)|((isfield(toolbar,'axesmenu')==1)&(strcmp(get(toolbar.axesmenu,'Checked'),'on')==1))|((isfield(toolbar,'rotate3d')==1)&(strcmp(get(toolbar.rotate3d,'State'),'on')==1))|(strcmp(tlock.wbdfcn,'move_light_fcn')==1)|((isfield(toolbar,'rectangle')==1)&(strcmp(get(toolbar.rectangle,'State'),'on')==1));
      set(h,'WindowButtonDownFcn',tlock.wbdfcn,'WindowButtonMotionFcn',tlock.wbmfcn,'WindowButtonUpFcn',tlock.wbufcn);
      set(h,'Interruptible',tlock.interruptible,'KeyPressFcn',tlock.keypressfcn,'ButtonDownFcn',tlock.buttondownfcn,'BusyAction',tlock.busyaction);
      set(h,'Pointer',tlock.pointer);
   else;
      set(h,'WindowButtonDownFcn','');
   end;
   set(h,'DoubleBuffer','off');
   set(toolbar.lock,'Label','Unloc&k Axes');
   labeltxt = 'Unlock Axes';
end;

for i=1:size(myaxes,2);
   set(myaxes(1,i),'Selected',act);
   if isempty(get(myaxes(1,i),'UIContextMenu'))==0;
      kids = get(get(myaxes(1,i),'UIContextMenu'),'Children')';
      for j=1:size(kids,2);
         if (strcmp(get(kids(1,j),'Label'),'Lock Axes')==1)|(strcmp(get(kids(1,j),'Label'),'Unlock Axes')==1);
            set(kids(1,j),'Label',labeltxt);
         end;
      end;
      if (strcmp(get(toolbar.lock,'Label'),'Loc&k Axes')==0)&((strcmp(get(toolbar.addtext,'State'),'on')==1)|(strcmp(get(toolbar.freehand,'State'),'on')==1)|(strcmp(get(toolbar.addarrow,'State'),'on')==1)|(strcmp(get(toolbar.addline,'State'),'on')==1)|(strcmp(get(toolbar.zoomin,'State'),'on')==1)|(strcmp(get(toolbar.zoomout,'State'),'on')==1)|((isfield(toolbar,'axesmenu')==1)&(strcmp(get(toolbar.axesmenu,'Checked'),'on')==1))|((isfield(toolbar,'rotate3d')==1)&(strcmp(get(toolbar.rotate3d,'State'),'on')==1)))|((isfield(toolbar,'rectangle')==1)&(strcmp(get(toolbar.rectangle,'State'),'on')==1));
         set(myaxes(1,i),'UIContextMenu',[]);
      end;
   else;
      if strcmp(get(toolbar.lock,'Label'),'Loc&k Axes')==1;
         if i<=size(old_myaxes,2);
            %
            % reset the axes context menu
            %
            create_axes_contextmenu_fcn(myaxes(1,i));
         end;
      end;
   end;
end;


for i=1:size(myaxes,2);
   set(myaxes(1,i),'Children',oldkids(i).handles);
end;

if isfield(toolbar,'lineentry')==1;
   set(toolbar.lineentry,'Visible','off');
   set(h,'UserData',toolbar);
end;

%
% end of toolbar_lock_fcn.m
%
