function toolbar_paperunits_fcn

h = get(0,'CurrentFigure');
toolbar = get(h,'UserData');
mypaperunits = get(h,'PaperUnits');

paperunitstype = strvcat('inches','centimeters','normalized','points');
if strcmp(mypaperunits,'inches')==1;
   mynum = 1;
elseif strcmp(mypaperunits,'centimeters')==1;
   mynum = 2;
elseif strcmp(mypaperunits,'normalized')==1;
   mynum = 3;
else,
   mynum = 4;
end;

[answer,newnum] = combodlg(paperunitstype,mynum,'Change Paper Units','Paper Units Selection',105,'Select paper unit:');

if strcmp(answer,'Cancel')==0;
   if abs(newnum-mynum)>0;
      newpaperunits = strrep(paperunitstype(newnum,:),' ','');
      set(h,'PaperUnits',newpaperunits);
      set(toolbar.paperunits,'Label',['Change Paper &Units (From: ' newpaperunits ')']);
   end;
end;

%
% end of toolbar_paperunits_fcn.m
%
