function toolbar_resize_fcn

%h = gcbo;
h = get(0,'CurrentFigure');
toolbar = get(h,'UserData');

if strcmp(get(h,'Visible'),'off')==1;
   return;
end;

fig_buffer = get(h,'DoubleBuffer');
if strcmp(fig_buffer,'off')==1;
   set(h,'DoubleBuffer','on');
end;

mypos = get(h,'Position');
width = mypos(1,3);
height = mypos(1,4);

if isempty(get(toolbar.edit,'UserData'))==0;
   axeshandles = get(toolbar.print,'UserData');
   legpositions = get(toolbar.edit,'UserData');
else;
   if isempty(get(toolbar.print,'UserData'))==0;
      axeshandles = get(toolbar.print,'UserData');
   else;
      axeshandles = [];
   end;
   legpositions = [];
end;

mysurf = [];
if isempty(axeshandles)==0;
   for i=1:size(axeshandles,2);
      newsurf = findobj(axeshandles(1,i),'Type','surface')';
      mysurf = [mysurf newsurf];
   end;
end;

%
% delete old toolbar
%

xbox1 = toolbar.box1;
%xbox2 = toolbar.box2;
%boxy = toolbar.ybox;
%boxy1 = toolbar.ybox1;

if isempty(mysurf)==0;
%   boxy2 = toolbar.ybox2;
%   boxy3 = toolbar.ybox3;
end;

%boxy4 = toolbar.ybox4;

if matlabnumber>=6.0;
   delete(xbox1(1,1));
   delete(xbox1(1,2));
   delete(xbox1(1,3));
%   delete(xbox2(1,1));
%   delete(xbox2(1,2));
%   delete(xbox2(1,3));
%   delete(boxy(1,1));
%   delete(boxy(1,2));
%   delete(boxy(1,3));
%   delete(boxy1(1,1));
%   delete(boxy1(1,2));
%   delete(boxy1(1,3));
%   if isempty(mysurf)==0;
%      delete(boxy2(1,1));
%      delete(boxy2(1,2));
%      delete(boxy2(1,3));
%      delete(boxy3(1,1));
%      delete(boxy3(1,2));
%      delete(boxy3(1,3));
%   end;
%   delete(boxy4(1,1));
%   delete(boxy4(1,2));
%   delete(boxy4(1,3));
else;
   delete(xbox1(1,1));
   delete(xbox1(1,2));
%   delete(xbox2(1,1));
%   delete(xbox2(1,2));
%   delete(boxy(1,1));
%   delete(boxy(1,2));
%   delete(boxy1(1,1));
%   delete(boxy1(1,2));
%   if isempty(mysurf)==0;
%      delete(boxy2(1,1));
%      delete(boxy2(1,2));
%      delete(boxy3(1,1));
%      delete(boxy3(1,2));
%   end;
%   delete(boxy4(1,1));
%   delete(boxy4(1,2));
end;

%
% move toolbar background
%

%set(toolbar.background,'Position',[1 height-38 width 40]);

%
% move buttons on toolbar
%

%set(toolbar.new,'Position',[10 height-30 22 22]);
%set(toolbar.open,'Position',[32 height-30 22 22]);
%set(toolbar.saveas,'Position',[68 height-30 22 22]);
%set(toolbar.print,'Position',[90 height-30 22 22]);
%set(toolbar.edit,'Position',[126 height-30 22 22]);
%set(toolbar.addtext,'Position',[148 height-30 22 22]);
%set(toolbar.addarrow,'Position',[170 height-30 22 22]);
%set(toolbar.addline,'Position',[192 height-30 22 22]);
addspace = 0;
if isempty(mysurf)==0;
   addspace = 36;
%   set(toolbar.rotate,'Position',[228 height-30 22 22]);
%   set(toolbar.rotate_default,'Position',[228 height-30 22 22]);
%   set(toolbar.left,'Position',[286 height-30 22 22]);
%   set(toolbar.up,'Position',[308 height-30 22 22]);
%   set(toolbar.down,'Position',[330 height-30 22 22]);
%   set(toolbar.right,'Position',[352 height-30 22 22]);
end;
%set(toolbar.zoomin,'Position',[228+addspace height-30 22 22]);
%set(toolbar.zoomout,'Position',[250+addspace height-30 22 22]);
%if isfield(toolbar,'rotate3d')==1;
%   set(toolbar.rotate3d,'Position',[272+addspace height-30 22 22]);
%end;

%
% set new x- and y-lines lines on toolbar
%

toolbar.box1 = xline([1 height-1 width],[0.5 1]);

%toolbar.box2 = xline([1 height-36 width],[0.5 1]);

%toolbar.ybox = yline([60 height-30 22],[0.5 1]);
%toolbar.ybox1 = yline([118 height-30 22],[0.5 1]);

%if isempty(mysurf)==0;
%   toolbar.ybox2 = yline([220 height-30 22],[0.5 1]);
%   toolbar.ybox3 = yline([278 height-30 22],[0.5 1]);
%end;

%toolbar.ybox4 = yline([220+addspace height-30 22],[0.5 1]);

set(h,'UserData',toolbar);

%
% fix legends so that they have the same size as in the original graph
%

if isempty(axeshandles)==0
   count = 0;
   curr_ini = find_inisettings;
   for j=1:size(axeshandles,2);
      if isempty(get(axeshandles(1,j),'UserData'))==0;
         count = count+1;
         old_leg = get(axeshandles(1,j),'UserData');
         oldlegpos = legpositions(count,:);
         leg_ud = get(old_leg,'UserData');
         %
         % get the new axes and legend positions in pixels
         %
         old_ax_units = get(axeshandles(1,j),'Units');
         set(axeshandles(1,j),'Units','pixels');
         ax_pos = get(axeshandles(1,j),'Position');
         set(axeshandles(1,j),'Units','normalized');
%         leg_ud.AxesPosition = get(axeshandles(1,j),'Position');
%         leg_ud.PlotPosition = get(axeshandles(1,j),'Position');
         set(axeshandles(1,j),'Units',old_ax_units);
         old_leg_units = get(old_leg,'Units');
         set(old_leg,'Units','pixels');
         new_legpos = get(old_leg,'Position');
         %
         % compare the lower left corners of axes and legend
         % to determine which quadrant of the axes the legend
         % is located in. the decision rule is to use the old
         % height and width of the legend, but position it based
         % on the quadrant.
         %
         %   upper left quadrant:  upper left corner
         %   upper right quadrant: upper right corner
         %   etc.
         %
         % if outside axes, then use lower left corner
         %
         lower_c = 0;
         left = 0;
         outside = 0;
         %
         % checking left/right
         %
         if (new_legpos(1)<ax_pos(1))|(new_legpos(1)+new_legpos(3)>ax_pos(1)+ax_pos(3));
            outside = 1;
         elseif new_legpos(1)-ax_pos(1)<(ax_pos(1)+ax_pos(3))-(new_legpos(1)+new_legpos(3));
            left = 1;
         end;
         if outside==0;
            if (new_legpos(2)<ax_pos(2))|(new_legpos(2)+new_legpos(4)>ax_pos(2)+ax_pos(4));
               outside = 1;
            elseif new_legpos(2)-ax_pos(2)<(ax_pos(2)+ax_pos(4))-(new_legpos(2)+new_legpos(4));
               lower_c = 1;
            end;
         end;
         %
         % outside or lower-left quadrant
         %
         if (outside==1)|((lower_c==1)&(left==1));
            pos = new_legpos(1:2);
         %
         % lower-right quandrant
         %
         elseif ((lower_c==1)&(left==0));
            pos = [(new_legpos(1)+(new_legpos(3)-oldlegpos(3))) new_legpos(2)];
         %
         % upper-left quadrant
         %
         elseif ((lower_c==0)&(left==1));
            pos = [new_legpos(1) (new_legpos(2)+(new_legpos(4)-oldlegpos(4)))];
         %
         % upper-right quandrant
         %
         else;
            pos = [(new_legpos(1)+(new_legpos(3)-oldlegpos(3))) (new_legpos(2)+(new_legpos(4)-oldlegpos(4)))];
         end;
         %
         % change legend position and size and update legend user data
         %
         set(old_leg,'Position',[pos oldlegpos(3:4)]);
         set(old_leg,'Units','normalized');
%         leg_ud.LegendPosition = get(old_leg,'Position');
         set(old_leg,'Units',old_leg_units,'UserData',leg_ud);  % 
      end;
      %
      % fix y-tick and x-tick marks if needed
      %
      if curr_ini.ytick==1;
         fixytix(axeshandles(1,j));
      end;
      if curr_ini.xtick==1;
         fixxtix(axeshandles(1,j));
      end;
   end;
end;

if strcmp(fig_buffer,'off')==1;
   set(h,'DoubleBuffer','off');
end;

%
% end of toolbar_resize_fcn.m
%
