function toolbar_show_hide_surface_fcn


h = get(0,'CurrentFigure');
toolbar = get(h,'UserData');
myaxes = get(toolbar.print,'UserData');

%
% Searching for surfaces
%

mysurf = [];
for i=1:size(myaxes,2);
   newsurf = findobj(myaxes(1,i),'Type','surface')';
   mysurf = [mysurf newsurf];
end;

if isempty(mysurf)==0;
   show_hide = get(toolbar.showhidesurface,'UserData');
   if show_hide==1;
      sh_action = 'off';
      set(toolbar.showhidesurface,'UserData',0);
      set(toolbar.showhidesurface,'Label','Show &Plane');
   else;
      sh_action = 'on';
      set(toolbar.showhidesurface,'UserData',1);
      set(toolbar.showhidesurface,'Label','Hide &Plane');
   end;
   for j=1:size(mysurf,2);
      if isnumeric(get(mysurf(1,j),'UserData'))==1;
         set(mysurf(1,j),'Visible',sh_action);
      end;
   end;
end;

%
% end of toolbar_show_hide_surface_fcn.m
%
