function update_legend_fcn

old_leg = get(gca,'UserData');
leg_ud = get(old_leg,'UserData');
old_strings = leg_ud.lstrings;
my_strings = '';
for i=1:size(old_strings,2);
   my_strings = strvcat(my_strings,old_strings{i});
end;

%
% check the object order for handles in the legend
%

if size(leg_ud.handles,1)>1;
   leg_ud.handles = leg_ud.handles';
end;
[sort_h,h_ind] = sort(leg_ud.handles);
leg_pos = leg_ud.legendpos;

%
% delete old legend and add a new one
%

delete_legend(old_leg);
add_legend_fcn(my_strings,h_ind,leg_pos);

%
% end of update_legend_fcn.m
%

