function stat = ispid(prog,pid)

stat = 0;
if nargin<2;
   return;
end;

curr_ini = find_inisettings;

if appexist([curr_ini.pstoolsdir 'pslist.exe'])==1;
   %
   % determine all pid's for prog
   %
   pid_prog = ['bin\run_exe.exe ' fix_path([curr_ini.pstoolsdir 'pslist.exe']) ' ' prog '>' fix_path([curr_ini.tempdir 'pid.txt'])];
   dos(pid_prog);
   txt = readtext([curr_ini.tempdir 'pid.txt']);
   if isempty(txt)==0;
      for i=1:size(txt,2);
         newtxt = txt{i};
         if size(newtxt,2)>size(prog,2);
            check_txt = newtxt(1,1:size(prog,2));
            if strcmp(lower(check_txt),lower(prog))==1;
               %
               % we have a match between program and a running process.
               % now check if current pid matches input pid
               %
               newtxt = strtrim(strrep(lower(newtxt),lower(prog),''));
               pos = findstr(newtxt,' ');
               if (isempty(pos)==0)&(pos(1)>1);
                  curr_pid = mystr2num(strtrim(newtxt(1,1:pos(1)-1)));
                  if curr_pid==pid;
                     stat = 1;
                     break;
                  end;
               end;
            end;
         end;
      end;
   end;
end;

%
% end of ispid.m
%
