function pj = finish_fcn( pj )
%Finish Method to end a PrintJob at its current page.
%   Finish current page and close connection to device or file output is 
%   beeing spooled to. Proper way to end a print job.
%   
%   See also CANCEL

%   Copyright 1984-2001 The MathWorks, Inc. 
%   $Revision: 1.3 $  $Date: 2001/04/15 11:59:44 $

pj.Active = 0;

%Tell internal driver
%if feature('NewPrintAPI')
%    err = hardcopy( pj, 'finish' )
%end
