function show_links

main_fig = findobj('Type','figure','Tag','StructuralVAR','Visible','on')';
model = [];
if (isempty(main_fig)==0)&(ishandle(main_fig)==1);
   model = get(main_fig,'UserData');
end;

fig = gcf;

co = overhiddenobj_fcn('axes');
if (isempty(co)==0)&(ishandle(co)==1);
   tag = get(co,'Tag');
   if (strcmp(tag,'url_axes')==1)|(strcmp(tag,'email_axes')==1);
      set(get(co,'UserData'),'Color',[1 0 0]);
      set(fig,'Pointer','custom','PointerShapeCData',link_pointer);
      if isempty(model)==0;
         if strcmp(tag,'url_axes')==1;
            email_handle = findobj(fig,'Type','text','Tag','email')';
            if (isempty(email_handle)==0)&(ishandle(email_handle)==1);
               set(email_handle,'Color',[0 0 1]);
            end;
            if isempty(model)==0;
               set(model.statusbar,'String',['Click on the link to visit: ' get(get(co,'UserData'),'String') '...']);
            end;
         elseif strcmp(tag,'email_axes')==1;
            url_handle = findobj(fig,'Type','text','Tag','url')';
            if (isempty(url_handle)==0)&(ishandle(url_handle)==1);
               set(url_handle,'Color',[0 0 1]);
            end;
            if isempty(model)==0;
               set(model.statusbar,'String',['Click on the link to write an email to: ' get(get(co,'UserData'),'String') '...']);
            end;
         end;
      end;
   else;
      if isempty(model)==0;
         set(model.statusbar,'String',get(model.quitdata,'UserData'));
      end;
      %
      % search for url and email tags
      %
%      url_handle = findobj(fig,'Type','text','Tag','url');
      url_handle = findobj('Type','text','Tag','url');
      if (isempty(url_handle)==0)&(ishandle(url_handle)==1);
         set(url_handle,'Color',[0 0 1]);
      end;
%      email_handle = findobj(fig,'Type','text','Tag','email');
      email_handle = findobj('Type','text','Tag','email');
      if (isempty(email_handle)==0)&(ishandle(email_handle)==1);
         set(email_handle,'Color',[0 0 1]);
      end;
      if ishandle(fig)==1;
         set(fig,'Pointer','arrow');
      end;
   end;
else;
   if isempty(model)==0;
      set(model.statusbar,'String',get(model.quitdata,'UserData'));
   end;
   %
   % search for url and email tags
   %
%   url_handle = findobj(fig,'Type','text','Tag','url');
   url_handle = findobj('Type','text','Tag','url');
   if (isempty(url_handle)==0)&(ishandle(url_handle)==1);
      set(url_handle,'Color',[0 0 1]);
   end;
%   email_handle = findobj(fig,'Type','text','Tag','email');
   email_handle = findobj('Type','text','Tag','email');
   if (isempty(email_handle)==0)&(ishandle(email_handle)==1);
      set(email_handle,'Color',[0 0 1]);
   end;
   if ishandle(fig)==1;
      set(fig,'Pointer','arrow');
   end;
end;

%
% end of show_links.m
%
