function stretch_patch(direction)

this_axes = gca;
my_patches = sort([findobj(this_axes,'Type','patch','Tag','rectpatch')' findobj(this_axes,'Type','patch','Tag','RECTPATCH')']);

if isempty(my_patches)==0;
   x_lim = get(this_axes,'XLim');
   y_lim = get(this_axes,'YLim');
   if strcmp(direction,'h')==1;
      for i=1:size(my_patches,2);
         x_data = [x_lim(1) x_lim(1) x_lim(1) x_lim(2) x_lim(2) x_lim(2) x_lim(2) x_lim(1)];
         set(my_patches(1,i),'XData',x_data);
      end;
   else;
      for i=1:size(my_patches,2);
         y_data = [y_lim(1) y_lim(2) y_lim(2) y_lim(2) y_lim(2) y_lim(1) y_lim(1) y_lim(1)];
         set(my_patches(1,i),'YData',y_data);
      end;
   end;
end;

%
% end of stretch_patch.m
%
